/* magnatune-db-reader.c generated by valac 0.16.0, the Vala compiler
 * generated from magnatune-db-reader.vala, do not modify */

/* magnatune-db-reader.vala
 *
 * Copyright (C) 2012  Jörn Magens
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The Xnoise authors hereby grant permission for non-GPL compatible
 *  GStreamer plugins to be used and distributed together with GStreamer
 *  and Xnoise. This permission is above and beyond the permissions granted
 *  by the GPL license by which Xnoise is covered. If you modify this code
 *  you may extend this exception to your version of the code, but you are not
 *  obligated to do so. If you do not wish to do so, delete this exception
 *  statement from your version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA.
 *
 * Author:
 *     Jörn Magens
 */

#include <glib.h>
#include <glib-object.h>
#include <xnoise-1.0.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <sqlite3.h>


#define TYPE_MAGNATUNE_DATABASE_READER (magnatune_database_reader_get_type ())
#define MAGNATUNE_DATABASE_READER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MAGNATUNE_DATABASE_READER, MagnatuneDatabaseReader))
#define MAGNATUNE_DATABASE_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MAGNATUNE_DATABASE_READER, MagnatuneDatabaseReaderClass))
#define IS_MAGNATUNE_DATABASE_READER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MAGNATUNE_DATABASE_READER))
#define IS_MAGNATUNE_DATABASE_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MAGNATUNE_DATABASE_READER))
#define MAGNATUNE_DATABASE_READER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MAGNATUNE_DATABASE_READER, MagnatuneDatabaseReaderClass))

typedef struct _MagnatuneDatabaseReader MagnatuneDatabaseReader;
typedef struct _MagnatuneDatabaseReaderClass MagnatuneDatabaseReaderClass;
typedef struct _MagnatuneDatabaseReaderPrivate MagnatuneDatabaseReaderPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _sqlite3_close0(var) ((var == NULL) ? NULL : (var = (sqlite3_close (var), NULL)))
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _xnoise_track_data_unref0(var) ((var == NULL) ? NULL : (var = (xnoise_track_data_unref (var), NULL)))
#define __vala_XnoiseItem_free0(var) ((var == NULL) ? NULL : (var = (_vala_XnoiseItem_free (var), NULL)))

struct _MagnatuneDatabaseReader {
	XnoiseDataSource parent_instance;
	MagnatuneDatabaseReaderPrivate * priv;
};

struct _MagnatuneDatabaseReaderClass {
	XnoiseDataSourceClass parent_class;
};

struct _MagnatuneDatabaseReaderPrivate {
	gchar* DATABASE;
	gchar* _username;
	gchar* _password;
	gchar* http_replacement;
	gboolean _login_data_available;
	GCancellable* cancel;
	sqlite3* db;
	sqlite3_stmt* get_artists_with_search_stmt;
	sqlite3_stmt* get_artists_with_search2_stmt;
};


static gpointer magnatune_database_reader_parent_class = NULL;
extern gchar* CONVERTED_DB;
static GType magnatune_database_reader_type_id = 0;

GType magnatune_database_reader_get_type (void) G_GNUC_CONST;
GType magnatune_database_reader_register_type (GTypeModule * module);
#define MAGNATUNE_DATABASE_READER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_MAGNATUNE_DATABASE_READER, MagnatuneDatabaseReaderPrivate))
enum  {
	MAGNATUNE_DATABASE_READER_DUMMY_PROPERTY,
	MAGNATUNE_DATABASE_READER_USERNAME,
	MAGNATUNE_DATABASE_READER_PASSWORD,
	MAGNATUNE_DATABASE_READER_LOGIN_DATA_AVAILABLE
};
#define MAGNATUNE_DATABASE_READER_data_source_name "MagnatuneDatabase"
#define MAGNATUNE_DATABASE_READER_STMT_TRACKDATA_FOR_URI "SELECT ar.name, al.name, t.title, t.tracknumber, t.length, t.mediatype" \
", t.id, g.name, t.year FROM artists ar, items t, albums al, uris u, ge" \
"nres g WHERE t.artist = ar.id AND t.album = al.id AND t.uri = u.id AND" \
" t.genre = g.id AND u.name = ?"
#define MAGNATUNE_DATABASE_READER_STMT_GET_ARTISTS_WITH_SEARCH "SELECT DISTINCT ar.id, ar.name FROM artists ar, items t, albums al, ge" \
"nres g WHERE t.artist = ar.id AND t.album = al.id AND t.genre = g.id A" \
"ND (utf8_lower(t.title) LIKE ? OR utf8_lower(al.name) LIKE ? OR utf8_l" \
"ower(ar.name) LIKE ? OR utf8_lower(g.name) LIKE ?) ORDER BY utf8_lower" \
"(ar.name) COLLATE CUSTOM01 DESC"
#define MAGNATUNE_DATABASE_READER_STMT_GET_ARTISTS "SELECT DISTINCT ar.id, ar.name FROM artists ar, items t WHERE t.artist" \
" = ar.id ORDER BY utf8_lower(ar.name) COLLATE CUSTOM01 DESC"
#define MAGNATUNE_DATABASE_READER_STMT_GET_TRACKDATA_BY_ARTISTID_WITH_SEARCH "SELECT t.title, t.mediatype, t.id, t.tracknumber, u.name, ar.name, al." \
"name, t.length, g.name, t.year FROM artists ar, items t, albums al, ur" \
"is u, genres g  WHERE t.artist = ar.id AND t.album = al.id AND t.uri =" \
" u.id AND t.genre = g.id AND ar.id = ? AND (utf8_lower(ar.name) LIKE ?" \
" OR utf8_lower(al.name) LIKE ? OR utf8_lower(t.title) LIKE ? OR utf8_l" \
"ower(g.name) LIKE ?) GROUP BY utf8_lower(t.title), al.id ORDER BY al.n" \
"ame COLLATE CUSTOM01 ASC, t.tracknumber ASC, t.title COLLATE CUSTOM01 " \
"ASC"
#define MAGNATUNE_DATABASE_READER_STMT_GET_TRACKDATA_BY_ARTISTID "SELECT t.title, t.mediatype, t.id, t.tracknumber, u.name, ar.name, al." \
"name, t.length, g.name, t.year  FROM artists ar, items t, albums al, u" \
"ris u, genres g WHERE t.artist = ar.id AND t.album = al.id AND t.uri =" \
" u.id AND t.genre = g.id AND ar.id = ? GROUP BY utf8_lower(t.title), a" \
"l.id ORDER BY al.name COLLATE CUSTOM01 ASC, t.tracknumber ASC, t.title" \
" COLLATE CUSTOM01 ASC"
#define MAGNATUNE_DATABASE_READER_STMT_GET_ARTISTITEM_BY_ARTISTID_WITH_SEARCH "SELECT DISTINCT ar.name FROM artists ar, items t, albums al, genres g " \
"WHERE t.artist = ar.id AND t.album = al.id AND t.genre = g.id AND ar.i" \
"d = ? AND (utf8_lower(ar.name) LIKE ? OR utf8_lower(al.name) LIKE ? OR" \
" utf8_lower(t.title) LIKE ? OR utf8_lower(g.name) LIKE ?)"
#define MAGNATUNE_DATABASE_READER_STMT_GET_ARTISTITEM_BY_ARTISTID "SELECT DISTINCT ar.name FROM artists ar, items t, albums al WHERE t.ar" \
"tist = ar.id AND t.album = al.id AND ar.id = ?"
#define MAGNATUNE_DATABASE_READER_STMT_GET_SKU_BY_ALBUMID "SELECT DISTINCT al.sku FROM albums al WHERE al.id = ?"
#define MAGNATUNE_DATABASE_READER_STMT_GET_SKU_BY_TITLEID "SELECT DISTINCT al.sku FROM items t, albums al WHERE t.album = al.id A" \
"ND t.id = ?"
#define MAGNATUNE_DATABASE_READER_STMT_GET_TRACKDATA_BY_ALBUMID_WITH_SEARCH "SELECT DISTINCT t.title, t.mediatype, t.id, t.tracknumber, u.name, ar." \
"name, al.name, t.length, g.name, t.year FROM artists ar, items t, albu" \
"ms al, uris u, genres g WHERE t.artist = ar.id AND t.album = al.id AND" \
" t.uri = u.id AND t.genre = g.id AND al.id = ? AND (utf8_lower(ar.name" \
") LIKE ? OR utf8_lower(al.name) LIKE ? OR utf8_lower(t.title) LIKE ? O" \
"R utf8_lower(g.name) LIKE ?) GROUP BY utf8_lower(t.title) ORDER BY t.t" \
"racknumber ASC, t.title COLLATE CUSTOM01 ASC"
#define MAGNATUNE_DATABASE_READER_STMT_GET_TRACKDATA_BY_ALBUMID "SELECT DISTINCT t.title, t.mediatype, t.id, t.tracknumber, u.name, ar." \
"name, al.name, t.length, g.name, t.year FROM artists ar, items t, albu" \
"ms al, uris u, genres g WHERE t.artist = ar.id AND t.album = al.id AND" \
" t.uri = u.id AND t.genre = g.id AND al.id = ? GROUP BY utf8_lower(t.t" \
"itle) ORDER BY t.tracknumber ASC, t.title COLLATE CUSTOM01 ASC"
#define MAGNATUNE_DATABASE_READER_STMT_GET_ALBUMS_WITH_SEARCH "SELECT DISTINCT al.name, al.id FROM artists ar, albums al, items t, ge" \
"nres g WHERE ar.id = t.artist AND al.id = t.album AND t.genre = g.id A" \
"ND ar.id = ? AND (utf8_lower(ar.name) LIKE ? OR utf8_lower(al.name) LI" \
"KE ? OR utf8_lower(t.title) LIKE ? OR utf8_lower(g.name) LIKE ?) ORDER" \
" BY utf8_lower(al.name) COLLATE CUSTOM01 ASC"
#define MAGNATUNE_DATABASE_READER_STMT_GET_ALBUMS "SELECT DISTINCT al.name, al.id FROM artists ar, albums al WHERE ar.id " \
"= al.artist AND ar.id = ? ORDER BY utf8_lower(al.name) COLLATE CUSTOM0" \
"1 ASC"
#define MAGNATUNE_DATABASE_READER_STMT_GET_TRACKDATA_BY_TITLEID "SELECT DISTINCT t.title, t.mediatype, t.id, t.tracknumber, u.name, ar." \
"name, al.name, t.length, g.name, t.year FROM artists ar, items t, albu" \
"ms al, uris u, genres g WHERE t.artist = ar.id AND t.album = al.id AND" \
" t.uri = u.id AND t.genre = g.id AND t.id = ?"
#define MAGNATUNE_DATABASE_READER_STMT_ALL_TRACKDATA "SELECT ar.name, al.name, t.title, t.tracknumber, t.mediatype, u.name, " \
"t.length, t.id, g.name, t.year FROM artists ar, items t, albums al, ur" \
"is u, genres g WHERE t.artist = ar.id AND t.album = al.id AND t.uri = " \
"u.id AND t.genre = g.id AND (utf8_lower(ar.name) LIKE ? OR utf8_lower(" \
"al.name) LIKE ? OR utf8_lower(t.title) LIKE ?) GROUP BY u.name ORDER B" \
"Y utf8_lower(ar.name) COLLATE CUSTOM01 ASC, utf8_lower(al.name) COLLAT" \
"E CUSTOM01 ASC, t.tracknumber ASC"
static gchar* magnatune_database_reader_transform_mag_url (MagnatuneDatabaseReader* self, const gchar* original_url);
MagnatuneDatabaseReader* magnatune_database_reader_new (GCancellable* cancel);
MagnatuneDatabaseReader* magnatune_database_reader_construct (GType object_type, GCancellable* cancel);
static gchar* magnatune_database_reader_dbFileName (MagnatuneDatabaseReader* self);
static void magnatune_database_reader_utf8_lower (sqlite3_context* context, int values_length1, sqlite3_value** values);
static void _magnatune_database_reader_utf8_lower_sqlite_user_func_callback (sqlite3_context* context, int values_length1, sqlite3_value** values);
static gint magnatune_database_reader_compare_func (gint alen, void* a, gint blen, void* b);
static gint _magnatune_database_reader_compare_func_sqlite_compare_callback (gpointer self, gint alen, void* a, gint blen, void* b);
void magnatune_database_reader_set_username (MagnatuneDatabaseReader* self, const gchar* value);
void magnatune_database_reader_set_password (MagnatuneDatabaseReader* self, const gchar* value);
static void magnatune_database_reader_db_error (MagnatuneDatabaseReader* self);
static const gchar* magnatune_database_reader_real_get_datasource_name (XnoiseDataSource* base);
static gboolean magnatune_database_reader_real_get_trackdata_for_uri (XnoiseDataSource* base, gchar** uri, XnoiseTrackData** val);
static XnoiseItem* _xnoise_item_dup (XnoiseItem* self);
static void _vala_XnoiseItem_free (XnoiseItem* self);
static XnoiseItem* magnatune_database_reader_real_get_artists_with_search (XnoiseDataSource* base, const gchar* searchtext, int* result_length1);
static void _vala_XnoiseItem_array_free (XnoiseItem* array, gint array_length);
static void _vala_array_add3 (XnoiseItem** array, int* length, int* size, const XnoiseItem* value);
static void _vala_array_add4 (XnoiseItem** array, int* length, int* size, const XnoiseItem* value);
static XnoiseTrackData** magnatune_database_reader_real_get_trackdata_by_artistid (XnoiseDataSource* base, const gchar* searchtext, gint32 id, int* result_length1);
static void _vala_array_add5 (XnoiseTrackData*** array, int* length, int* size, XnoiseTrackData* value);
static XnoiseItem* magnatune_database_reader_real_get_artistitem_by_artistid (XnoiseDataSource* base, const gchar* searchtext, gint32 id);
gchar* magnatune_database_reader_get_sku_for_album (MagnatuneDatabaseReader* self, gint32 id);
gchar* magnatune_database_reader_get_sku_for_title (MagnatuneDatabaseReader* self, gint32 id);
static XnoiseTrackData** magnatune_database_reader_real_get_trackdata_by_albumid (XnoiseDataSource* base, const gchar* searchtext, gint32 id, int* result_length1);
static void _vala_array_add6 (XnoiseTrackData*** array, int* length, int* size, XnoiseTrackData* value);
static XnoiseItem* magnatune_database_reader_real_get_albums_with_search (XnoiseDataSource* base, const gchar* searchtext, gint32 id, int* result_length1);
static void _vala_array_add7 (XnoiseItem** array, int* length, int* size, const XnoiseItem* value);
static XnoiseTrackData* magnatune_database_reader_real_get_trackdata_by_titleid (XnoiseDataSource* base, const gchar* searchtext, gint32 id);
static gboolean magnatune_database_reader_real_get_stream_td_for_id (XnoiseDataSource* base, gint32 id, XnoiseTrackData** val);
static XnoiseTrackData** magnatune_database_reader_real_get_all_tracks (XnoiseDataSource* base, const gchar* searchtext, int* result_length1);
static void _vala_array_add8 (XnoiseTrackData*** array, int* length, int* size, XnoiseTrackData* value);
const gchar* magnatune_database_reader_get_username (MagnatuneDatabaseReader* self);
void magnatune_database_reader_set_login_data_available (MagnatuneDatabaseReader* self, gboolean value);
const gchar* magnatune_database_reader_get_password (MagnatuneDatabaseReader* self);
gboolean magnatune_database_reader_get_login_data_available (MagnatuneDatabaseReader* self);
static void magnatune_database_reader_finalize (GObject* obj);
static void _vala_magnatune_database_reader_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_magnatune_database_reader_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	{
		const gchar* _tmp0_;
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_;
		GRegex* _tmp3_;
		GRegex* _tmp4_;
		GRegex* regex;
		GRegex* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_ = NULL;
		gchar* _tmp8_;
		_tmp0_ = old;
		_tmp1_ = g_regex_escape_string (_tmp0_, -1);
		_tmp2_ = _tmp1_;
		_tmp3_ = g_regex_new (_tmp2_, 0, 0, &_inner_error_);
		_tmp4_ = _tmp3_;
		_g_free0 (_tmp2_);
		regex = _tmp4_;
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch25_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp5_ = regex;
		_tmp6_ = replacement;
		_tmp7_ = g_regex_replace_literal (_tmp5_, self, (gssize) (-1), 0, _tmp6_, 0, &_inner_error_);
		_tmp8_ = _tmp7_;
		if (_inner_error_ != NULL) {
			_g_regex_unref0 (regex);
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch25_g_regex_error;
			}
			_g_regex_unref0 (regex);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		result = _tmp8_;
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally25;
	__catch25_g_regex_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally25:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


static gint string_last_index_of (const gchar* self, const gchar* needle, gint start_index) {
	gint result = 0;
	gint _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _result_;
	gchar* _tmp3_;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (needle != NULL, 0);
	_tmp0_ = start_index;
	_tmp1_ = needle;
	_tmp2_ = g_strrstr (((gchar*) self) + _tmp0_, (gchar*) _tmp1_);
	_result_ = _tmp2_;
	_tmp3_ = _result_;
	if (_tmp3_ != NULL) {
		gchar* _tmp4_;
		_tmp4_ = _result_;
		result = (gint) (_tmp4_ - ((gchar*) self));
		return result;
	} else {
		result = -1;
		return result;
	}
}


static glong string_strnlen (gchar* str, glong maxlen) {
	glong result = 0L;
	gchar* _tmp0_;
	glong _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* end;
	gchar* _tmp3_;
	_tmp0_ = str;
	_tmp1_ = maxlen;
	_tmp2_ = memchr (_tmp0_, 0, (gsize) _tmp1_);
	end = _tmp2_;
	_tmp3_ = end;
	if (_tmp3_ == NULL) {
		glong _tmp4_;
		_tmp4_ = maxlen;
		result = _tmp4_;
		return result;
	} else {
		gchar* _tmp5_;
		gchar* _tmp6_;
		_tmp5_ = end;
		_tmp6_ = str;
		result = (glong) (_tmp5_ - _tmp6_);
		return result;
	}
}


static gchar* string_substring (const gchar* self, glong offset, glong len) {
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp1_;
	gboolean _tmp3_;
	glong _tmp9_;
	glong _tmp15_;
	glong _tmp18_;
	glong _tmp19_;
	glong _tmp20_;
	glong _tmp21_;
	glong _tmp22_;
	gchar* _tmp23_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = offset;
	if (_tmp1_ >= ((glong) 0)) {
		glong _tmp2_;
		_tmp2_ = len;
		_tmp0_ = _tmp2_ >= ((glong) 0);
	} else {
		_tmp0_ = FALSE;
	}
	_tmp3_ = _tmp0_;
	if (_tmp3_) {
		glong _tmp4_;
		glong _tmp5_;
		glong _tmp6_ = 0L;
		_tmp4_ = offset;
		_tmp5_ = len;
		_tmp6_ = string_strnlen ((gchar*) self, _tmp4_ + _tmp5_);
		string_length = _tmp6_;
	} else {
		gint _tmp7_;
		gint _tmp8_;
		_tmp7_ = strlen (self);
		_tmp8_ = _tmp7_;
		string_length = (glong) _tmp8_;
	}
	_tmp9_ = offset;
	if (_tmp9_ < ((glong) 0)) {
		glong _tmp10_;
		glong _tmp11_;
		glong _tmp12_;
		_tmp10_ = string_length;
		_tmp11_ = offset;
		offset = _tmp10_ + _tmp11_;
		_tmp12_ = offset;
		g_return_val_if_fail (_tmp12_ >= ((glong) 0), NULL);
	} else {
		glong _tmp13_;
		glong _tmp14_;
		_tmp13_ = offset;
		_tmp14_ = string_length;
		g_return_val_if_fail (_tmp13_ <= _tmp14_, NULL);
	}
	_tmp15_ = len;
	if (_tmp15_ < ((glong) 0)) {
		glong _tmp16_;
		glong _tmp17_;
		_tmp16_ = string_length;
		_tmp17_ = offset;
		len = _tmp16_ - _tmp17_;
	}
	_tmp18_ = offset;
	_tmp19_ = len;
	_tmp20_ = string_length;
	g_return_val_if_fail ((_tmp18_ + _tmp19_) <= _tmp20_, NULL);
	_tmp21_ = offset;
	_tmp22_ = len;
	_tmp23_ = g_strndup (((gchar*) self) + _tmp21_, (gsize) _tmp22_);
	result = _tmp23_;
	return result;
}


static gchar* magnatune_database_reader_transform_mag_url (MagnatuneDatabaseReader* self, const gchar* original_url) {
	gchar* result = NULL;
	gboolean _tmp0_;
	const gchar* _tmp3_;
	gchar* url = NULL;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_ = NULL;
	gchar* suff = NULL;
	gint inx = 0;
	const gchar* _tmp8_;
	gint _tmp9_ = 0;
	gint _tmp10_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (original_url != NULL, NULL);
	_tmp0_ = self->priv->_login_data_available;
	if (!_tmp0_) {
		const gchar* _tmp1_;
		gchar* _tmp2_;
		_tmp1_ = original_url;
		_tmp2_ = g_strdup (_tmp1_);
		result = _tmp2_;
		return result;
	}
	_tmp3_ = original_url;
	if (_tmp3_ == NULL) {
		gchar* _tmp4_;
		_tmp4_ = g_strdup (XNOISE_RESOURCES_EMPTYSTRING);
		result = _tmp4_;
		return result;
	}
	_tmp5_ = original_url;
	_tmp6_ = self->priv->http_replacement;
	_tmp7_ = string_replace (_tmp5_, "http://he3.magnatune.com", _tmp6_);
	_g_free0 (url);
	url = _tmp7_;
	_tmp8_ = url;
	_tmp9_ = string_last_index_of (_tmp8_, ".", 0);
	inx = _tmp9_;
	_tmp10_ = inx;
	if (_tmp10_ != (-1)) {
		const gchar* _tmp11_;
		gint _tmp12_;
		const gchar* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
		gint _tmp16_;
		gchar* _tmp17_ = NULL;
		const gchar* _tmp18_;
		gint _tmp19_;
		gchar* _tmp20_ = NULL;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		const gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		_tmp11_ = url;
		_tmp12_ = inx;
		_tmp13_ = url;
		_tmp14_ = strlen (_tmp13_);
		_tmp15_ = _tmp14_;
		_tmp16_ = inx;
		_tmp17_ = string_substring (_tmp11_, (glong) (_tmp12_ + 1), (glong) ((_tmp15_ - _tmp16_) - 1));
		_g_free0 (suff);
		suff = _tmp17_;
		_tmp18_ = url;
		_tmp19_ = inx;
		_tmp20_ = string_substring (_tmp18_, (glong) 0, (glong) _tmp19_);
		_tmp21_ = _tmp20_;
		_tmp22_ = g_strconcat (_tmp21_, "_nospeech.", NULL);
		_tmp23_ = _tmp22_;
		_tmp24_ = suff;
		_tmp25_ = g_strconcat (_tmp23_, _tmp24_, NULL);
		_tmp26_ = _tmp25_;
		_g_free0 (_tmp23_);
		_g_free0 (_tmp21_);
		result = _tmp26_;
		_g_free0 (suff);
		_g_free0 (url);
		return result;
	} else {
		result = url;
		_g_free0 (suff);
		return result;
	}
	_g_free0 (suff);
	_g_free0 (url);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void _magnatune_database_reader_utf8_lower_sqlite_user_func_callback (sqlite3_context* context, int values_length1, sqlite3_value** values) {
	magnatune_database_reader_utf8_lower (context, values_length1, values);
}


static gint _magnatune_database_reader_compare_func_sqlite_compare_callback (gpointer self, gint alen, void* a, gint blen, void* b) {
	gint result;
	result = magnatune_database_reader_compare_func (alen, a, blen, b);
	return result;
}


MagnatuneDatabaseReader* magnatune_database_reader_construct (GType object_type, GCancellable* cancel) {
	MagnatuneDatabaseReader * self = NULL;
	GCancellable* _tmp0_;
	GCancellable* _tmp1_;
	gchar* _tmp2_ = NULL;
	const gchar* _tmp3_;
	sqlite3* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	sqlite3* _tmp7_;
	sqlite3* _tmp8_;
	sqlite3* _tmp9_;
	sqlite3* _tmp10_;
	sqlite3_stmt* _tmp11_ = NULL;
	sqlite3* _tmp12_;
	sqlite3_stmt* _tmp13_ = NULL;
	gchar* _tmp14_ = NULL;
	gchar* _tmp15_;
	gchar* _tmp16_ = NULL;
	gchar* _tmp17_;
	g_return_val_if_fail (cancel != NULL, NULL);
	self = (MagnatuneDatabaseReader*) xnoise_data_source_construct (object_type);
	_tmp0_ = cancel;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->cancel);
	self->priv->cancel = _tmp1_;
	_tmp2_ = magnatune_database_reader_dbFileName (self);
	_g_free0 (self->priv->DATABASE);
	self->priv->DATABASE = _tmp2_;
	_sqlite3_close0 (self->priv->db);
	self->priv->db = NULL;
	_tmp3_ = self->priv->DATABASE;
	_tmp5_ = sqlite3_open_v2 (_tmp3_, &_tmp4_, SQLITE_OPEN_READONLY, NULL);
	_sqlite3_close0 (self->priv->db);
	self->priv->db = _tmp4_;
	if (_tmp5_ != SQLITE_OK) {
		sqlite3* _tmp6_;
		_tmp6_ = self->priv->db;
		g_error ("magnatune-db-reader.vala:109: Can't open magnatune database: %s\n", (const gchar*) sqlite3_errmsg);
	}
	_tmp7_ = self->priv->db;
	if (_tmp7_ == NULL) {
		g_error ("magnatune-db-reader.vala:112: magnatune db failed");
	}
	_tmp8_ = self->priv->db;
	sqlite3_create_function_v2 (_tmp8_, "utf8_lower", 1, SQLITE_ANY, NULL, _magnatune_database_reader_utf8_lower_sqlite_user_func_callback, NULL, NULL, NULL);
	_tmp9_ = self->priv->db;
	sqlite3_create_collation (_tmp9_, "CUSTOM01", SQLITE_UTF8, NULL, (int (*)(void *, int,  const void *, int,  const void *)) _magnatune_database_reader_compare_func_sqlite_compare_callback);
	_tmp10_ = self->priv->db;
	sqlite3_prepare_v2 (_tmp10_, MAGNATUNE_DATABASE_READER_STMT_GET_ARTISTS_WITH_SEARCH, -1, &_tmp11_, NULL);
	_sqlite3_finalize0 (self->priv->get_artists_with_search_stmt);
	self->priv->get_artists_with_search_stmt = _tmp11_;
	_tmp12_ = self->priv->db;
	sqlite3_prepare_v2 (_tmp12_, MAGNATUNE_DATABASE_READER_STMT_GET_ARTISTS, -1, &_tmp13_, NULL);
	_sqlite3_finalize0 (self->priv->get_artists_with_search2_stmt);
	self->priv->get_artists_with_search2_stmt = _tmp13_;
	_tmp14_ = xnoise_params_get_string_value ("magnatune_user");
	_tmp15_ = _tmp14_;
	magnatune_database_reader_set_username (self, _tmp15_);
	_g_free0 (_tmp15_);
	_tmp16_ = xnoise_params_get_string_value ("magnatune_pass");
	_tmp17_ = _tmp16_;
	magnatune_database_reader_set_password (self, _tmp17_);
	_g_free0 (_tmp17_);
	return self;
}


MagnatuneDatabaseReader* magnatune_database_reader_new (GCancellable* cancel) {
	return magnatune_database_reader_construct (TYPE_MAGNATUNE_DATABASE_READER, cancel);
}


static void magnatune_database_reader_utf8_lower (sqlite3_context* context, int values_length1, sqlite3_value** values) {
	sqlite3_context* _tmp0_;
	sqlite3_value** _tmp1_;
	gint _tmp1__length1;
	sqlite3_value* _tmp2_;
	const gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	GDestroyNotify _tmp5_;
	g_return_if_fail (context != NULL);
	_tmp0_ = context;
	_tmp1_ = values;
	_tmp1__length1 = values_length1;
	_tmp2_ = _tmp1_[0];
	_tmp3_ = sqlite3_value_text (_tmp2_);
	_tmp4_ = g_utf8_strdown (_tmp3_, (gssize) (-1));
	_tmp5_ = g_free;
	sqlite3_result_text (_tmp0_, _tmp4_, -1, _tmp5_);
}


static gint magnatune_database_reader_compare_func (gint alen, void* a, gint blen, void* b) {
	gint result = 0;
	GCompareFunc _tmp0_;
	void* _tmp1_;
	gint _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	void* _tmp5_;
	gint _tmp6_;
	gchar* _tmp7_ = NULL;
	gchar* _tmp8_;
	gint _tmp9_ = 0;
	gint _tmp10_;
	_tmp0_ = g_strcmp0;
	_tmp1_ = a;
	_tmp2_ = alen;
	_tmp3_ = g_utf8_collate_key ((const gchar*) _tmp1_, (gssize) _tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = b;
	_tmp6_ = blen;
	_tmp7_ = g_utf8_collate_key ((const gchar*) _tmp5_, (gssize) _tmp6_);
	_tmp8_ = _tmp7_;
	_tmp9_ = _tmp0_ (_tmp4_, _tmp8_);
	_tmp10_ = _tmp9_;
	_g_free0 (_tmp8_);
	_g_free0 (_tmp4_);
	result = _tmp10_;
	return result;
}


static gchar* magnatune_database_reader_dbFileName (MagnatuneDatabaseReader* self) {
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = CONVERTED_DB;
	_tmp1_ = g_strdup (_tmp0_);
	result = _tmp1_;
	return result;
}


static void magnatune_database_reader_db_error (MagnatuneDatabaseReader* self) {
	sqlite3* _tmp0_;
	gint _tmp1_ = 0;
	sqlite3* _tmp2_;
	const gchar* _tmp3_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->db;
	_tmp1_ = sqlite3_errcode (_tmp0_);
	_tmp2_ = self->priv->db;
	_tmp3_ = sqlite3_errmsg (_tmp2_);
	g_print ("Database error %d: %s \n\n", _tmp1_, _tmp3_);
}


static const gchar* magnatune_database_reader_real_get_datasource_name (XnoiseDataSource* base) {
	MagnatuneDatabaseReader * self;
	const gchar* result = NULL;
	self = (MagnatuneDatabaseReader*) base;
	result = MAGNATUNE_DATABASE_READER_data_source_name;
	return result;
}


static XnoiseItem* _xnoise_item_dup (XnoiseItem* self) {
	XnoiseItem* dup;
	dup = g_new0 (XnoiseItem, 1);
	xnoise_item_copy (self, dup);
	return dup;
}


static gpointer __xnoise_item_dup0 (gpointer self) {
	return self ? _xnoise_item_dup (self) : NULL;
}


static void _vala_XnoiseItem_free (XnoiseItem* self) {
	xnoise_item_destroy (self);
	g_free (self);
}


static gboolean magnatune_database_reader_real_get_trackdata_for_uri (XnoiseDataSource* base, gchar** uri, XnoiseTrackData** val) {
	MagnatuneDatabaseReader * self;
	XnoiseTrackData* _vala_val = NULL;
	gboolean result = FALSE;
	gboolean retval;
	XnoiseTrackData* _tmp0_;
	const gchar* _tmp1_;
	sqlite3_stmt* stmt = NULL;
	sqlite3* _tmp2_;
	sqlite3_stmt* _tmp3_ = NULL;
	gboolean found;
	sqlite3_stmt* _tmp4_;
	sqlite3_stmt* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	GDestroyNotify _tmp8_;
	sqlite3_stmt* _tmp9_;
	gint _tmp10_ = 0;
	gboolean _tmp48_;
	XnoiseTrackData* _tmp95_;
	const gchar* _tmp96_;
	XnoiseTrackData* _tmp97_;
	const gchar* _tmp98_;
	XnoiseTrackData* _tmp101_;
	const gchar* _tmp102_;
	XnoiseTrackData* _tmp103_;
	const gchar* _tmp104_;
	XnoiseTrackData* _tmp107_;
	const gchar* _tmp108_;
	XnoiseTrackData* _tmp109_;
	const gchar* _tmp110_;
	XnoiseTrackData* _tmp113_;
	const gchar* _tmp114_;
	XnoiseTrackData* _tmp115_;
	const gchar* _tmp116_;
	self = (MagnatuneDatabaseReader*) base;
	retval = FALSE;
	_tmp0_ = xnoise_track_data_new ();
	_xnoise_track_data_unref0 (_vala_val);
	_vala_val = _tmp0_;
	_tmp1_ = *uri;
	if (_tmp1_ == NULL) {
		result = retval;
		if (val) {
			*val = _vala_val;
		} else {
			_xnoise_track_data_unref0 (_vala_val);
		}
		return result;
	}
	_tmp2_ = self->priv->db;
	sqlite3_prepare_v2 (_tmp2_, MAGNATUNE_DATABASE_READER_STMT_TRACKDATA_FOR_URI, -1, &_tmp3_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp3_;
	found = FALSE;
	_tmp4_ = stmt;
	sqlite3_reset (_tmp4_);
	_tmp5_ = stmt;
	_tmp6_ = *uri;
	_tmp7_ = g_strdup (_tmp6_);
	_tmp8_ = g_free;
	sqlite3_bind_text (_tmp5_, 1, _tmp7_, -1, _tmp8_);
	_tmp9_ = stmt;
	_tmp10_ = sqlite3_step (_tmp9_);
	if (_tmp10_ == SQLITE_ROW) {
		XnoiseTrackData* _tmp11_;
		sqlite3_stmt* _tmp12_;
		const gchar* _tmp13_ = NULL;
		gchar* _tmp14_;
		XnoiseTrackData* _tmp15_;
		sqlite3_stmt* _tmp16_;
		const gchar* _tmp17_ = NULL;
		gchar* _tmp18_;
		XnoiseTrackData* _tmp19_;
		sqlite3_stmt* _tmp20_;
		const gchar* _tmp21_ = NULL;
		gchar* _tmp22_;
		XnoiseTrackData* _tmp23_;
		sqlite3_stmt* _tmp24_;
		gint _tmp25_ = 0;
		XnoiseTrackData* _tmp26_;
		sqlite3_stmt* _tmp27_;
		gint _tmp28_ = 0;
		XnoiseTrackData* _tmp29_;
		sqlite3_stmt* _tmp30_;
		gint _tmp31_ = 0;
		const gchar* _tmp32_;
		sqlite3_stmt* _tmp33_;
		gint _tmp34_ = 0;
		XnoiseItem _tmp35_ = {0};
		XnoiseItem _tmp36_;
		XnoiseItem* _tmp37_;
		XnoiseTrackData* _tmp38_;
		XnoiseItem* _tmp39_;
		gint _tmp40_ = 0;
		XnoiseTrackData* _tmp41_;
		sqlite3_stmt* _tmp42_;
		const gchar* _tmp43_ = NULL;
		gchar* _tmp44_;
		XnoiseTrackData* _tmp45_;
		sqlite3_stmt* _tmp46_;
		gint _tmp47_ = 0;
		_tmp11_ = _vala_val;
		_tmp12_ = stmt;
		_tmp13_ = sqlite3_column_text (_tmp12_, 0);
		_tmp14_ = g_strdup (_tmp13_);
		_g_free0 (_tmp11_->artist);
		_tmp11_->artist = _tmp14_;
		_tmp15_ = _vala_val;
		_tmp16_ = stmt;
		_tmp17_ = sqlite3_column_text (_tmp16_, 1);
		_tmp18_ = g_strdup (_tmp17_);
		_g_free0 (_tmp15_->album);
		_tmp15_->album = _tmp18_;
		_tmp19_ = _vala_val;
		_tmp20_ = stmt;
		_tmp21_ = sqlite3_column_text (_tmp20_, 2);
		_tmp22_ = g_strdup (_tmp21_);
		_g_free0 (_tmp19_->title);
		_tmp19_->title = _tmp22_;
		_tmp23_ = _vala_val;
		_tmp24_ = stmt;
		_tmp25_ = sqlite3_column_int (_tmp24_, 3);
		_tmp23_->tracknumber = (guint) _tmp25_;
		_tmp26_ = _vala_val;
		_tmp27_ = stmt;
		_tmp28_ = sqlite3_column_int (_tmp27_, 4);
		_tmp26_->length = (gint32) _tmp28_;
		_tmp29_ = _vala_val;
		_tmp30_ = stmt;
		_tmp31_ = sqlite3_column_int (_tmp30_, 5);
		_tmp32_ = *uri;
		_tmp33_ = stmt;
		_tmp34_ = sqlite3_column_int (_tmp33_, 6);
		xnoise_item_init (&_tmp35_, (XnoiseItemType) _tmp31_, _tmp32_, (gint32) _tmp34_);
		_tmp36_ = _tmp35_;
		_tmp37_ = __xnoise_item_dup0 (&_tmp36_);
		__vala_XnoiseItem_free0 (_tmp29_->item);
		_tmp29_->item = _tmp37_;
		xnoise_item_destroy (&_tmp36_);
		_tmp38_ = _vala_val;
		_tmp39_ = _tmp38_->item;
		_tmp40_ = xnoise_data_source_get_source_id ((XnoiseDataSource*) self);
		(*_tmp39_).source_id = _tmp40_;
		_tmp41_ = _vala_val;
		_tmp42_ = stmt;
		_tmp43_ = sqlite3_column_text (_tmp42_, 7);
		_tmp44_ = g_strdup (_tmp43_);
		_g_free0 (_tmp41_->genre);
		_tmp41_->genre = _tmp44_;
		_tmp45_ = _vala_val;
		_tmp46_ = stmt;
		_tmp47_ = sqlite3_column_int (_tmp46_, 8);
		_tmp45_->year = (guint) _tmp47_;
		retval = TRUE;
		found = TRUE;
	}
	_tmp48_ = found;
	if (_tmp48_ == FALSE) {
		sqlite3_stmt* _tmp49_;
		const gchar* _tmp50_;
		gchar* _tmp51_ = NULL;
		gchar* turi;
		sqlite3_stmt* _tmp52_;
		const gchar* _tmp53_;
		gchar* _tmp54_;
		GDestroyNotify _tmp55_;
		sqlite3_stmt* _tmp56_;
		gint _tmp57_ = 0;
		_tmp49_ = stmt;
		sqlite3_reset (_tmp49_);
		_tmp50_ = *uri;
		_tmp51_ = magnatune_database_reader_transform_mag_url (self, _tmp50_);
		turi = _tmp51_;
		_tmp52_ = stmt;
		_tmp53_ = turi;
		_tmp54_ = g_strdup (_tmp53_);
		_tmp55_ = g_free;
		sqlite3_bind_text (_tmp52_, 1, _tmp54_, -1, _tmp55_);
		_tmp56_ = stmt;
		_tmp57_ = sqlite3_step (_tmp56_);
		if (_tmp57_ == SQLITE_ROW) {
			XnoiseTrackData* _tmp58_;
			sqlite3_stmt* _tmp59_;
			const gchar* _tmp60_ = NULL;
			gchar* _tmp61_;
			XnoiseTrackData* _tmp62_;
			sqlite3_stmt* _tmp63_;
			const gchar* _tmp64_ = NULL;
			gchar* _tmp65_;
			XnoiseTrackData* _tmp66_;
			sqlite3_stmt* _tmp67_;
			const gchar* _tmp68_ = NULL;
			gchar* _tmp69_;
			XnoiseTrackData* _tmp70_;
			sqlite3_stmt* _tmp71_;
			gint _tmp72_ = 0;
			XnoiseTrackData* _tmp73_;
			sqlite3_stmt* _tmp74_;
			gint _tmp75_ = 0;
			XnoiseTrackData* _tmp76_;
			sqlite3_stmt* _tmp77_;
			gint _tmp78_ = 0;
			const gchar* _tmp79_;
			sqlite3_stmt* _tmp80_;
			gint _tmp81_ = 0;
			XnoiseItem _tmp82_ = {0};
			XnoiseItem _tmp83_;
			XnoiseItem* _tmp84_;
			XnoiseTrackData* _tmp85_;
			XnoiseItem* _tmp86_;
			gint _tmp87_ = 0;
			XnoiseTrackData* _tmp88_;
			sqlite3_stmt* _tmp89_;
			const gchar* _tmp90_ = NULL;
			gchar* _tmp91_;
			XnoiseTrackData* _tmp92_;
			sqlite3_stmt* _tmp93_;
			gint _tmp94_ = 0;
			_tmp58_ = _vala_val;
			_tmp59_ = stmt;
			_tmp60_ = sqlite3_column_text (_tmp59_, 0);
			_tmp61_ = g_strdup (_tmp60_);
			_g_free0 (_tmp58_->artist);
			_tmp58_->artist = _tmp61_;
			_tmp62_ = _vala_val;
			_tmp63_ = stmt;
			_tmp64_ = sqlite3_column_text (_tmp63_, 1);
			_tmp65_ = g_strdup (_tmp64_);
			_g_free0 (_tmp62_->album);
			_tmp62_->album = _tmp65_;
			_tmp66_ = _vala_val;
			_tmp67_ = stmt;
			_tmp68_ = sqlite3_column_text (_tmp67_, 2);
			_tmp69_ = g_strdup (_tmp68_);
			_g_free0 (_tmp66_->title);
			_tmp66_->title = _tmp69_;
			_tmp70_ = _vala_val;
			_tmp71_ = stmt;
			_tmp72_ = sqlite3_column_int (_tmp71_, 3);
			_tmp70_->tracknumber = (guint) _tmp72_;
			_tmp73_ = _vala_val;
			_tmp74_ = stmt;
			_tmp75_ = sqlite3_column_int (_tmp74_, 4);
			_tmp73_->length = (gint32) _tmp75_;
			_tmp76_ = _vala_val;
			_tmp77_ = stmt;
			_tmp78_ = sqlite3_column_int (_tmp77_, 5);
			_tmp79_ = turi;
			_tmp80_ = stmt;
			_tmp81_ = sqlite3_column_int (_tmp80_, 6);
			xnoise_item_init (&_tmp82_, (XnoiseItemType) _tmp78_, _tmp79_, (gint32) _tmp81_);
			_tmp83_ = _tmp82_;
			_tmp84_ = __xnoise_item_dup0 (&_tmp83_);
			__vala_XnoiseItem_free0 (_tmp76_->item);
			_tmp76_->item = _tmp84_;
			xnoise_item_destroy (&_tmp83_);
			_tmp85_ = _vala_val;
			_tmp86_ = _tmp85_->item;
			_tmp87_ = xnoise_data_source_get_source_id ((XnoiseDataSource*) self);
			(*_tmp86_).source_id = _tmp87_;
			_tmp88_ = _vala_val;
			_tmp89_ = stmt;
			_tmp90_ = sqlite3_column_text (_tmp89_, 7);
			_tmp91_ = g_strdup (_tmp90_);
			_g_free0 (_tmp88_->genre);
			_tmp88_->genre = _tmp91_;
			_tmp92_ = _vala_val;
			_tmp93_ = stmt;
			_tmp94_ = sqlite3_column_int (_tmp93_, 8);
			_tmp92_->year = (guint) _tmp94_;
			retval = TRUE;
		}
		_g_free0 (turi);
	}
	_tmp95_ = _vala_val;
	_tmp96_ = _tmp95_->artist;
	_tmp97_ = _vala_val;
	_tmp98_ = _tmp97_->artist;
	if ((g_strcmp0 (_tmp96_, XNOISE_RESOURCES_EMPTYSTRING) == 0) | (_tmp98_ == NULL)) {
		XnoiseTrackData* _tmp99_;
		gchar* _tmp100_;
		_tmp99_ = _vala_val;
		_tmp100_ = g_strdup (XNOISE_RESOURCES_UNKNOWN_ARTIST);
		_g_free0 (_tmp99_->artist);
		_tmp99_->artist = _tmp100_;
	}
	_tmp101_ = _vala_val;
	_tmp102_ = _tmp101_->album;
	_tmp103_ = _vala_val;
	_tmp104_ = _tmp103_->album;
	if ((g_strcmp0 (_tmp102_, XNOISE_RESOURCES_EMPTYSTRING) == 0) | (_tmp104_ == NULL)) {
		XnoiseTrackData* _tmp105_;
		gchar* _tmp106_;
		_tmp105_ = _vala_val;
		_tmp106_ = g_strdup (XNOISE_RESOURCES_UNKNOWN_ALBUM);
		_g_free0 (_tmp105_->album);
		_tmp105_->album = _tmp106_;
	}
	_tmp107_ = _vala_val;
	_tmp108_ = _tmp107_->genre;
	_tmp109_ = _vala_val;
	_tmp110_ = _tmp109_->genre;
	if ((g_strcmp0 (_tmp108_, XNOISE_RESOURCES_EMPTYSTRING) == 0) | (_tmp110_ == NULL)) {
		XnoiseTrackData* _tmp111_;
		gchar* _tmp112_;
		_tmp111_ = _vala_val;
		_tmp112_ = g_strdup (XNOISE_RESOURCES_UNKNOWN_GENRE);
		_g_free0 (_tmp111_->genre);
		_tmp111_->genre = _tmp112_;
	}
	_tmp113_ = _vala_val;
	_tmp114_ = _tmp113_->title;
	_tmp115_ = _vala_val;
	_tmp116_ = _tmp115_->title;
	if ((g_strcmp0 (_tmp114_, XNOISE_RESOURCES_EMPTYSTRING) == 0) | (_tmp116_ == NULL)) {
		XnoiseTrackData* _tmp117_;
		gchar* _tmp118_;
		const gchar* _tmp119_;
		GFile* _tmp120_ = NULL;
		GFile* file;
		GFile* _tmp121_;
		gchar* _tmp122_ = NULL;
		gchar* fpath;
		gchar* _tmp123_;
		gchar* fileBasename;
		const gchar* _tmp124_;
		XnoiseTrackData* _tmp127_;
		const gchar* _tmp128_;
		gchar* _tmp129_;
		_tmp117_ = _vala_val;
		_tmp118_ = g_strdup (XNOISE_RESOURCES_UNKNOWN_TITLE);
		_g_free0 (_tmp117_->title);
		_tmp117_->title = _tmp118_;
		_tmp119_ = *uri;
		_tmp120_ = g_file_new_for_uri (_tmp119_);
		file = _tmp120_;
		_tmp121_ = file;
		_tmp122_ = g_file_get_path (_tmp121_);
		fpath = _tmp122_;
		_tmp123_ = g_strdup (XNOISE_RESOURCES_EMPTYSTRING);
		fileBasename = _tmp123_;
		_tmp124_ = fpath;
		if (_tmp124_ != NULL) {
			const gchar* _tmp125_;
			gchar* _tmp126_ = NULL;
			_tmp125_ = fpath;
			_tmp126_ = g_filename_display_basename (_tmp125_);
			_g_free0 (fileBasename);
			fileBasename = _tmp126_;
		}
		_tmp127_ = _vala_val;
		_tmp128_ = fileBasename;
		_tmp129_ = g_strdup (_tmp128_);
		_g_free0 (_tmp127_->title);
		_tmp127_->title = _tmp129_;
		_g_free0 (fileBasename);
		_g_free0 (fpath);
		_g_object_unref0 (file);
	}
	result = retval;
	_sqlite3_finalize0 (stmt);
	if (val) {
		*val = _vala_val;
	} else {
		_xnoise_track_data_unref0 (_vala_val);
	}
	return result;
}


static void _vala_XnoiseItem_array_free (XnoiseItem* array, gint array_length) {
	if (array != NULL) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			xnoise_item_destroy (&array[i]);
		}
	}
	g_free (array);
}


static void _vala_array_add3 (XnoiseItem** array, int* length, int* size, const XnoiseItem* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (XnoiseItem, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


static void _vala_array_add4 (XnoiseItem** array, int* length, int* size, const XnoiseItem* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (XnoiseItem, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


static XnoiseItem* magnatune_database_reader_real_get_artists_with_search (XnoiseDataSource* base, const gchar* searchtext, int* result_length1) {
	MagnatuneDatabaseReader * self;
	XnoiseItem* result = NULL;
	XnoiseItem* _tmp0_ = NULL;
	XnoiseItem* val;
	gint val_length1;
	gint _val_size_;
	GCancellable* _tmp1_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp4_;
	XnoiseItem* _tmp65_;
	gint _tmp65__length1;
	XnoiseItem* _tmp66_;
	gint _tmp66__length1;
	self = (MagnatuneDatabaseReader*) base;
	g_return_val_if_fail (searchtext != NULL, NULL);
	_tmp0_ = g_new0 (XnoiseItem, 0);
	val = _tmp0_;
	val_length1 = 0;
	_val_size_ = val_length1;
	_tmp1_ = self->priv->cancel;
	_tmp2_ = g_cancellable_is_cancelled (_tmp1_);
	if (_tmp2_) {
		XnoiseItem* _tmp3_;
		gint _tmp3__length1;
		_tmp3_ = val;
		_tmp3__length1 = val_length1;
		if (result_length1) {
			*result_length1 = _tmp3__length1;
		}
		result = _tmp3_;
		return result;
	}
	_tmp4_ = searchtext;
	if (g_strcmp0 (_tmp4_, XNOISE_RESOURCES_EMPTYSTRING) != 0) {
		const gchar* _tmp5_;
		gchar* _tmp6_ = NULL;
		gchar* st;
		sqlite3_stmt* _tmp7_;
		gboolean _tmp8_ = FALSE;
		gboolean _tmp9_ = FALSE;
		gboolean _tmp10_ = FALSE;
		sqlite3_stmt* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		GDestroyNotify _tmp14_;
		gint _tmp15_ = 0;
		gboolean _tmp21_;
		gboolean _tmp27_;
		gboolean _tmp33_;
		_tmp5_ = searchtext;
		_tmp6_ = g_strdup_printf ("%%%s%%", _tmp5_);
		st = _tmp6_;
		_tmp7_ = self->priv->get_artists_with_search_stmt;
		sqlite3_reset (_tmp7_);
		_tmp11_ = self->priv->get_artists_with_search_stmt;
		_tmp12_ = st;
		_tmp13_ = g_strdup (_tmp12_);
		_tmp14_ = g_free;
		_tmp15_ = sqlite3_bind_text (_tmp11_, 1, _tmp13_, -1, _tmp14_);
		if (_tmp15_ != SQLITE_OK) {
			_tmp10_ = TRUE;
		} else {
			sqlite3_stmt* _tmp16_;
			const gchar* _tmp17_;
			gchar* _tmp18_;
			GDestroyNotify _tmp19_;
			gint _tmp20_ = 0;
			_tmp16_ = self->priv->get_artists_with_search_stmt;
			_tmp17_ = st;
			_tmp18_ = g_strdup (_tmp17_);
			_tmp19_ = g_free;
			_tmp20_ = sqlite3_bind_text (_tmp16_, 2, _tmp18_, -1, _tmp19_);
			_tmp10_ = _tmp20_ != SQLITE_OK;
		}
		_tmp21_ = _tmp10_;
		if (_tmp21_) {
			_tmp9_ = TRUE;
		} else {
			sqlite3_stmt* _tmp22_;
			const gchar* _tmp23_;
			gchar* _tmp24_;
			GDestroyNotify _tmp25_;
			gint _tmp26_ = 0;
			_tmp22_ = self->priv->get_artists_with_search_stmt;
			_tmp23_ = st;
			_tmp24_ = g_strdup (_tmp23_);
			_tmp25_ = g_free;
			_tmp26_ = sqlite3_bind_text (_tmp22_, 3, _tmp24_, -1, _tmp25_);
			_tmp9_ = _tmp26_ != SQLITE_OK;
		}
		_tmp27_ = _tmp9_;
		if (_tmp27_) {
			_tmp8_ = TRUE;
		} else {
			sqlite3_stmt* _tmp28_;
			const gchar* _tmp29_;
			gchar* _tmp30_;
			GDestroyNotify _tmp31_;
			gint _tmp32_ = 0;
			_tmp28_ = self->priv->get_artists_with_search_stmt;
			_tmp29_ = st;
			_tmp30_ = g_strdup (_tmp29_);
			_tmp31_ = g_free;
			_tmp32_ = sqlite3_bind_text (_tmp28_, 4, _tmp30_, -1, _tmp31_);
			_tmp8_ = _tmp32_ != SQLITE_OK;
		}
		_tmp33_ = _tmp8_;
		if (_tmp33_) {
			XnoiseItem* _tmp34_;
			gint _tmp34__length1;
			XnoiseItem* _tmp35_;
			gint _tmp35__length1;
			magnatune_database_reader_db_error (self);
			_tmp34_ = val;
			_tmp34__length1 = val_length1;
			val = NULL;
			_tmp35_ = _tmp34_;
			_tmp35__length1 = _tmp34__length1;
			if (result_length1) {
				*result_length1 = _tmp35__length1;
			}
			result = _tmp35_;
			_g_free0 (st);
			val = (_vala_XnoiseItem_array_free (val, val_length1), NULL);
			return result;
		}
		while (TRUE) {
			sqlite3_stmt* _tmp36_;
			gint _tmp37_ = 0;
			GCancellable* _tmp38_;
			gboolean _tmp39_ = FALSE;
			sqlite3_stmt* _tmp41_;
			gint _tmp42_ = 0;
			XnoiseItem i = {0};
			sqlite3_stmt* _tmp43_;
			const gchar* _tmp44_ = NULL;
			gchar* _tmp45_;
			gint _tmp46_ = 0;
			XnoiseItem* _tmp47_;
			gint _tmp47__length1;
			XnoiseItem _tmp48_;
			XnoiseItem _tmp49_ = {0};
			_tmp36_ = self->priv->get_artists_with_search_stmt;
			_tmp37_ = sqlite3_step (_tmp36_);
			if (!(_tmp37_ == SQLITE_ROW)) {
				break;
			}
			_tmp38_ = self->priv->cancel;
			_tmp39_ = g_cancellable_is_cancelled (_tmp38_);
			if (_tmp39_) {
				XnoiseItem* _tmp40_;
				gint _tmp40__length1;
				_tmp40_ = val;
				_tmp40__length1 = val_length1;
				if (result_length1) {
					*result_length1 = _tmp40__length1;
				}
				result = _tmp40_;
				_g_free0 (st);
				return result;
			}
			_tmp41_ = self->priv->get_artists_with_search_stmt;
			_tmp42_ = sqlite3_column_int (_tmp41_, 0);
			xnoise_item_init (&i, XNOISE_ITEM_TYPE_COLLECTION_CONTAINER_ARTIST, NULL, (gint32) _tmp42_);
			_tmp43_ = self->priv->get_artists_with_search_stmt;
			_tmp44_ = sqlite3_column_text (_tmp43_, 1);
			_tmp45_ = g_strdup (_tmp44_);
			_g_free0 (i.text);
			i.text = _tmp45_;
			_tmp46_ = xnoise_data_source_get_source_id ((XnoiseDataSource*) self);
			i.source_id = _tmp46_;
			_tmp47_ = val;
			_tmp47__length1 = val_length1;
			_tmp48_ = i;
			xnoise_item_copy (&_tmp48_, &_tmp49_);
			_vala_array_add3 (&val, &val_length1, &_val_size_, &_tmp49_);
			xnoise_item_destroy (&i);
		}
		_g_free0 (st);
	} else {
		sqlite3_stmt* _tmp50_;
		_tmp50_ = self->priv->get_artists_with_search2_stmt;
		sqlite3_reset (_tmp50_);
		while (TRUE) {
			sqlite3_stmt* _tmp51_;
			gint _tmp52_ = 0;
			GCancellable* _tmp53_;
			gboolean _tmp54_ = FALSE;
			sqlite3_stmt* _tmp56_;
			gint _tmp57_ = 0;
			XnoiseItem i = {0};
			sqlite3_stmt* _tmp58_;
			const gchar* _tmp59_ = NULL;
			gchar* _tmp60_;
			gint _tmp61_ = 0;
			XnoiseItem* _tmp62_;
			gint _tmp62__length1;
			XnoiseItem _tmp63_;
			XnoiseItem _tmp64_ = {0};
			_tmp51_ = self->priv->get_artists_with_search2_stmt;
			_tmp52_ = sqlite3_step (_tmp51_);
			if (!(_tmp52_ == SQLITE_ROW)) {
				break;
			}
			_tmp53_ = self->priv->cancel;
			_tmp54_ = g_cancellable_is_cancelled (_tmp53_);
			if (_tmp54_) {
				XnoiseItem* _tmp55_;
				gint _tmp55__length1;
				_tmp55_ = val;
				_tmp55__length1 = val_length1;
				if (result_length1) {
					*result_length1 = _tmp55__length1;
				}
				result = _tmp55_;
				return result;
			}
			_tmp56_ = self->priv->get_artists_with_search2_stmt;
			_tmp57_ = sqlite3_column_int (_tmp56_, 0);
			xnoise_item_init (&i, XNOISE_ITEM_TYPE_COLLECTION_CONTAINER_ARTIST, NULL, (gint32) _tmp57_);
			_tmp58_ = self->priv->get_artists_with_search2_stmt;
			_tmp59_ = sqlite3_column_text (_tmp58_, 1);
			_tmp60_ = g_strdup (_tmp59_);
			_g_free0 (i.text);
			i.text = _tmp60_;
			_tmp61_ = xnoise_data_source_get_source_id ((XnoiseDataSource*) self);
			i.source_id = _tmp61_;
			_tmp62_ = val;
			_tmp62__length1 = val_length1;
			_tmp63_ = i;
			xnoise_item_copy (&_tmp63_, &_tmp64_);
			_vala_array_add4 (&val, &val_length1, &_val_size_, &_tmp64_);
			xnoise_item_destroy (&i);
		}
	}
	_tmp65_ = val;
	_tmp65__length1 = val_length1;
	val = NULL;
	_tmp66_ = _tmp65_;
	_tmp66__length1 = _tmp65__length1;
	if (result_length1) {
		*result_length1 = _tmp66__length1;
	}
	result = _tmp66_;
	val = (_vala_XnoiseItem_array_free (val, val_length1), NULL);
	return result;
}


static gpointer _xnoise_track_data_ref0 (gpointer self) {
	return self ? xnoise_track_data_ref (self) : NULL;
}


static void _vala_array_add5 (XnoiseTrackData*** array, int* length, int* size, XnoiseTrackData* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (XnoiseTrackData*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static XnoiseTrackData** magnatune_database_reader_real_get_trackdata_by_artistid (XnoiseDataSource* base, const gchar* searchtext, gint32 id, int* result_length1) {
	MagnatuneDatabaseReader * self;
	XnoiseTrackData** result = NULL;
	XnoiseTrackData** _tmp0_ = NULL;
	XnoiseTrackData** val;
	gint val_length1;
	gint _val_size_;
	sqlite3_stmt* stmt = NULL;
	const gchar* _tmp1_;
	XnoiseTrackData** _tmp93_;
	gint _tmp93__length1;
	XnoiseTrackData** _tmp94_;
	gint _tmp94__length1;
	self = (MagnatuneDatabaseReader*) base;
	g_return_val_if_fail (searchtext != NULL, NULL);
	_tmp0_ = g_new0 (XnoiseTrackData*, 0 + 1);
	val = _tmp0_;
	val_length1 = 0;
	_val_size_ = val_length1;
	_tmp1_ = searchtext;
	if (g_strcmp0 (_tmp1_, XNOISE_RESOURCES_EMPTYSTRING) != 0) {
		const gchar* _tmp2_;
		gchar* _tmp3_ = NULL;
		gchar* st;
		sqlite3* _tmp4_;
		sqlite3_stmt* _tmp5_ = NULL;
		gboolean _tmp6_ = FALSE;
		gboolean _tmp7_ = FALSE;
		gboolean _tmp8_ = FALSE;
		gboolean _tmp9_ = FALSE;
		sqlite3_stmt* _tmp10_;
		gint32 _tmp11_;
		gint _tmp12_ = 0;
		gboolean _tmp18_;
		gboolean _tmp24_;
		gboolean _tmp30_;
		gboolean _tmp36_;
		_tmp2_ = searchtext;
		_tmp3_ = g_strdup_printf ("%%%s%%", _tmp2_);
		st = _tmp3_;
		_tmp4_ = self->priv->db;
		sqlite3_prepare_v2 (_tmp4_, MAGNATUNE_DATABASE_READER_STMT_GET_TRACKDATA_BY_ARTISTID_WITH_SEARCH, -1, &_tmp5_, NULL);
		_sqlite3_finalize0 (stmt);
		stmt = _tmp5_;
		_tmp10_ = stmt;
		_tmp11_ = id;
		_tmp12_ = sqlite3_bind_int (_tmp10_, 1, (gint) _tmp11_);
		if (_tmp12_ != SQLITE_OK) {
			_tmp9_ = TRUE;
		} else {
			sqlite3_stmt* _tmp13_;
			const gchar* _tmp14_;
			gchar* _tmp15_;
			GDestroyNotify _tmp16_;
			gint _tmp17_ = 0;
			_tmp13_ = stmt;
			_tmp14_ = st;
			_tmp15_ = g_strdup (_tmp14_);
			_tmp16_ = g_free;
			_tmp17_ = sqlite3_bind_text (_tmp13_, 2, _tmp15_, -1, _tmp16_);
			_tmp9_ = _tmp17_ != SQLITE_OK;
		}
		_tmp18_ = _tmp9_;
		if (_tmp18_) {
			_tmp8_ = TRUE;
		} else {
			sqlite3_stmt* _tmp19_;
			const gchar* _tmp20_;
			gchar* _tmp21_;
			GDestroyNotify _tmp22_;
			gint _tmp23_ = 0;
			_tmp19_ = stmt;
			_tmp20_ = st;
			_tmp21_ = g_strdup (_tmp20_);
			_tmp22_ = g_free;
			_tmp23_ = sqlite3_bind_text (_tmp19_, 3, _tmp21_, -1, _tmp22_);
			_tmp8_ = _tmp23_ != SQLITE_OK;
		}
		_tmp24_ = _tmp8_;
		if (_tmp24_) {
			_tmp7_ = TRUE;
		} else {
			sqlite3_stmt* _tmp25_;
			const gchar* _tmp26_;
			gchar* _tmp27_;
			GDestroyNotify _tmp28_;
			gint _tmp29_ = 0;
			_tmp25_ = stmt;
			_tmp26_ = st;
			_tmp27_ = g_strdup (_tmp26_);
			_tmp28_ = g_free;
			_tmp29_ = sqlite3_bind_text (_tmp25_, 4, _tmp27_, -1, _tmp28_);
			_tmp7_ = _tmp29_ != SQLITE_OK;
		}
		_tmp30_ = _tmp7_;
		if (_tmp30_) {
			_tmp6_ = TRUE;
		} else {
			sqlite3_stmt* _tmp31_;
			const gchar* _tmp32_;
			gchar* _tmp33_;
			GDestroyNotify _tmp34_;
			gint _tmp35_ = 0;
			_tmp31_ = stmt;
			_tmp32_ = st;
			_tmp33_ = g_strdup (_tmp32_);
			_tmp34_ = g_free;
			_tmp35_ = sqlite3_bind_text (_tmp31_, 5, _tmp33_, -1, _tmp34_);
			_tmp6_ = _tmp35_ != SQLITE_OK;
		}
		_tmp36_ = _tmp6_;
		if (_tmp36_) {
			XnoiseTrackData** _tmp37_;
			gint _tmp37__length1;
			XnoiseTrackData** _tmp38_;
			gint _tmp38__length1;
			magnatune_database_reader_db_error (self);
			_tmp37_ = val;
			_tmp37__length1 = val_length1;
			val = NULL;
			_tmp38_ = _tmp37_;
			_tmp38__length1 = _tmp37__length1;
			if (result_length1) {
				*result_length1 = _tmp38__length1;
			}
			result = _tmp38_;
			_g_free0 (st);
			_sqlite3_finalize0 (stmt);
			val = (_vala_array_free (val, val_length1, (GDestroyNotify) xnoise_track_data_unref), NULL);
			return result;
		}
		_g_free0 (st);
	} else {
		sqlite3* _tmp39_;
		sqlite3_stmt* _tmp40_ = NULL;
		sqlite3_stmt* _tmp41_;
		gint32 _tmp42_;
		gint _tmp43_ = 0;
		_tmp39_ = self->priv->db;
		sqlite3_prepare_v2 (_tmp39_, MAGNATUNE_DATABASE_READER_STMT_GET_TRACKDATA_BY_ARTISTID, -1, &_tmp40_, NULL);
		_sqlite3_finalize0 (stmt);
		stmt = _tmp40_;
		_tmp41_ = stmt;
		_tmp42_ = id;
		_tmp43_ = sqlite3_bind_int (_tmp41_, 1, (gint) _tmp42_);
		if (_tmp43_ != SQLITE_OK) {
			XnoiseTrackData** _tmp44_;
			gint _tmp44__length1;
			magnatune_database_reader_db_error (self);
			_tmp44_ = NULL;
			_tmp44__length1 = 0;
			if (result_length1) {
				*result_length1 = _tmp44__length1;
			}
			result = _tmp44_;
			_sqlite3_finalize0 (stmt);
			val = (_vala_array_free (val, val_length1, (GDestroyNotify) xnoise_track_data_unref), NULL);
			return result;
		}
	}
	while (TRUE) {
		sqlite3_stmt* _tmp45_;
		gint _tmp46_ = 0;
		XnoiseTrackData* _tmp47_;
		XnoiseTrackData* td;
		sqlite3_stmt* _tmp48_;
		gint _tmp49_ = 0;
		sqlite3_stmt* _tmp50_;
		const gchar* _tmp51_ = NULL;
		gchar* _tmp52_ = NULL;
		gchar* _tmp53_;
		sqlite3_stmt* _tmp54_;
		gint _tmp55_ = 0;
		XnoiseItem _tmp56_ = {0};
		XnoiseItem _tmp57_;
		XnoiseItem* _tmp58_;
		XnoiseItem* _tmp59_;
		XnoiseItem* i;
		XnoiseItem* _tmp60_;
		gint _tmp61_ = 0;
		XnoiseTrackData* _tmp62_;
		sqlite3_stmt* _tmp63_;
		const gchar* _tmp64_ = NULL;
		gchar* _tmp65_;
		XnoiseTrackData* _tmp66_;
		sqlite3_stmt* _tmp67_;
		const gchar* _tmp68_ = NULL;
		gchar* _tmp69_;
		XnoiseTrackData* _tmp70_;
		sqlite3_stmt* _tmp71_;
		const gchar* _tmp72_ = NULL;
		gchar* _tmp73_;
		XnoiseTrackData* _tmp74_;
		XnoiseItem* _tmp75_;
		XnoiseItem* _tmp76_;
		XnoiseTrackData* _tmp77_;
		sqlite3_stmt* _tmp78_;
		gint _tmp79_ = 0;
		XnoiseTrackData* _tmp80_;
		sqlite3_stmt* _tmp81_;
		gint _tmp82_ = 0;
		XnoiseTrackData* _tmp83_;
		sqlite3_stmt* _tmp84_;
		const gchar* _tmp85_ = NULL;
		gchar* _tmp86_;
		XnoiseTrackData* _tmp87_;
		sqlite3_stmt* _tmp88_;
		gint _tmp89_ = 0;
		XnoiseTrackData** _tmp90_;
		gint _tmp90__length1;
		XnoiseTrackData* _tmp91_;
		XnoiseTrackData* _tmp92_;
		_tmp45_ = stmt;
		_tmp46_ = sqlite3_step (_tmp45_);
		if (!(_tmp46_ == SQLITE_ROW)) {
			break;
		}
		_tmp47_ = xnoise_track_data_new ();
		td = _tmp47_;
		_tmp48_ = stmt;
		_tmp49_ = sqlite3_column_int (_tmp48_, 1);
		_tmp50_ = stmt;
		_tmp51_ = sqlite3_column_text (_tmp50_, 4);
		_tmp52_ = magnatune_database_reader_transform_mag_url (self, _tmp51_);
		_tmp53_ = _tmp52_;
		_tmp54_ = stmt;
		_tmp55_ = sqlite3_column_int (_tmp54_, 2);
		xnoise_item_init (&_tmp56_, (XnoiseItemType) _tmp49_, _tmp53_, (gint32) _tmp55_);
		_tmp57_ = _tmp56_;
		_tmp58_ = __xnoise_item_dup0 (&_tmp57_);
		_tmp59_ = _tmp58_;
		xnoise_item_destroy (&_tmp57_);
		_g_free0 (_tmp53_);
		i = _tmp59_;
		_tmp60_ = i;
		_tmp61_ = xnoise_data_source_get_source_id ((XnoiseDataSource*) self);
		(*_tmp60_).source_id = _tmp61_;
		_tmp62_ = td;
		_tmp63_ = stmt;
		_tmp64_ = sqlite3_column_text (_tmp63_, 5);
		_tmp65_ = g_strdup (_tmp64_);
		_g_free0 (_tmp62_->artist);
		_tmp62_->artist = _tmp65_;
		_tmp66_ = td;
		_tmp67_ = stmt;
		_tmp68_ = sqlite3_column_text (_tmp67_, 6);
		_tmp69_ = g_strdup (_tmp68_);
		_g_free0 (_tmp66_->album);
		_tmp66_->album = _tmp69_;
		_tmp70_ = td;
		_tmp71_ = stmt;
		_tmp72_ = sqlite3_column_text (_tmp71_, 0);
		_tmp73_ = g_strdup (_tmp72_);
		_g_free0 (_tmp70_->title);
		_tmp70_->title = _tmp73_;
		_tmp74_ = td;
		_tmp75_ = i;
		_tmp76_ = __xnoise_item_dup0 (_tmp75_);
		__vala_XnoiseItem_free0 (_tmp74_->item);
		_tmp74_->item = _tmp76_;
		_tmp77_ = td;
		_tmp78_ = stmt;
		_tmp79_ = sqlite3_column_int (_tmp78_, 3);
		_tmp77_->tracknumber = (guint) _tmp79_;
		_tmp80_ = td;
		_tmp81_ = stmt;
		_tmp82_ = sqlite3_column_int (_tmp81_, 7);
		_tmp80_->length = (gint32) _tmp82_;
		_tmp83_ = td;
		_tmp84_ = stmt;
		_tmp85_ = sqlite3_column_text (_tmp84_, 8);
		_tmp86_ = g_strdup (_tmp85_);
		_g_free0 (_tmp83_->genre);
		_tmp83_->genre = _tmp86_;
		_tmp87_ = td;
		_tmp88_ = stmt;
		_tmp89_ = sqlite3_column_int (_tmp88_, 9);
		_tmp87_->year = (guint) _tmp89_;
		_tmp90_ = val;
		_tmp90__length1 = val_length1;
		_tmp91_ = td;
		_tmp92_ = _xnoise_track_data_ref0 (_tmp91_);
		_vala_array_add5 (&val, &val_length1, &_val_size_, _tmp92_);
		__vala_XnoiseItem_free0 (i);
		_xnoise_track_data_unref0 (td);
	}
	_tmp93_ = val;
	_tmp93__length1 = val_length1;
	val = NULL;
	_tmp94_ = _tmp93_;
	_tmp94__length1 = _tmp93__length1;
	if (result_length1) {
		*result_length1 = _tmp94__length1;
	}
	result = _tmp94_;
	_sqlite3_finalize0 (stmt);
	val = (_vala_array_free (val, val_length1, (GDestroyNotify) xnoise_track_data_unref), NULL);
	return result;
}


static XnoiseItem* magnatune_database_reader_real_get_artistitem_by_artistid (XnoiseDataSource* base, const gchar* searchtext, gint32 id) {
	MagnatuneDatabaseReader * self;
	XnoiseItem* result = NULL;
	sqlite3_stmt* stmt = NULL;
	XnoiseItem _tmp0_ = {0};
	XnoiseItem _tmp1_;
	XnoiseItem* _tmp2_;
	XnoiseItem* _tmp3_;
	XnoiseItem* i;
	XnoiseItem* _tmp4_;
	gint _tmp5_ = 0;
	const gchar* _tmp6_;
	sqlite3_stmt* _tmp42_;
	gint _tmp43_ = 0;
	XnoiseItem* _tmp54_;
	self = (MagnatuneDatabaseReader*) base;
	g_return_val_if_fail (searchtext != NULL, NULL);
	xnoise_item_init (&_tmp0_, XNOISE_ITEM_TYPE_UNKNOWN, NULL, (gint32) (-1));
	_tmp1_ = _tmp0_;
	_tmp2_ = __xnoise_item_dup0 (&_tmp1_);
	_tmp3_ = _tmp2_;
	xnoise_item_destroy (&_tmp1_);
	i = _tmp3_;
	_tmp4_ = i;
	_tmp5_ = xnoise_data_source_get_source_id ((XnoiseDataSource*) self);
	(*_tmp4_).source_id = _tmp5_;
	_tmp6_ = searchtext;
	if (g_strcmp0 (_tmp6_, XNOISE_RESOURCES_EMPTYSTRING) != 0) {
		const gchar* _tmp7_;
		gchar* _tmp8_ = NULL;
		gchar* st;
		sqlite3* _tmp9_;
		sqlite3_stmt* _tmp10_ = NULL;
		gboolean _tmp11_ = FALSE;
		gboolean _tmp12_ = FALSE;
		gboolean _tmp13_ = FALSE;
		sqlite3_stmt* _tmp14_;
		gint32 _tmp15_;
		gint _tmp16_ = 0;
		gboolean _tmp22_;
		gboolean _tmp28_;
		gboolean _tmp34_;
		_tmp7_ = searchtext;
		_tmp8_ = g_strdup_printf ("%%%s%%", _tmp7_);
		st = _tmp8_;
		_tmp9_ = self->priv->db;
		sqlite3_prepare_v2 (_tmp9_, MAGNATUNE_DATABASE_READER_STMT_GET_ARTISTITEM_BY_ARTISTID_WITH_SEARCH, -1, &_tmp10_, NULL);
		_sqlite3_finalize0 (stmt);
		stmt = _tmp10_;
		_tmp14_ = stmt;
		_tmp15_ = id;
		_tmp16_ = sqlite3_bind_int (_tmp14_, 1, (gint) _tmp15_);
		if (_tmp16_ != SQLITE_OK) {
			_tmp13_ = TRUE;
		} else {
			sqlite3_stmt* _tmp17_;
			const gchar* _tmp18_;
			gchar* _tmp19_;
			GDestroyNotify _tmp20_;
			gint _tmp21_ = 0;
			_tmp17_ = stmt;
			_tmp18_ = st;
			_tmp19_ = g_strdup (_tmp18_);
			_tmp20_ = g_free;
			_tmp21_ = sqlite3_bind_text (_tmp17_, 2, _tmp19_, -1, _tmp20_);
			_tmp13_ = _tmp21_ != SQLITE_OK;
		}
		_tmp22_ = _tmp13_;
		if (_tmp22_) {
			_tmp12_ = TRUE;
		} else {
			sqlite3_stmt* _tmp23_;
			const gchar* _tmp24_;
			gchar* _tmp25_;
			GDestroyNotify _tmp26_;
			gint _tmp27_ = 0;
			_tmp23_ = stmt;
			_tmp24_ = st;
			_tmp25_ = g_strdup (_tmp24_);
			_tmp26_ = g_free;
			_tmp27_ = sqlite3_bind_text (_tmp23_, 3, _tmp25_, -1, _tmp26_);
			_tmp12_ = _tmp27_ != SQLITE_OK;
		}
		_tmp28_ = _tmp12_;
		if (_tmp28_) {
			_tmp11_ = TRUE;
		} else {
			sqlite3_stmt* _tmp29_;
			const gchar* _tmp30_;
			gchar* _tmp31_;
			GDestroyNotify _tmp32_;
			gint _tmp33_ = 0;
			_tmp29_ = stmt;
			_tmp30_ = st;
			_tmp31_ = g_strdup (_tmp30_);
			_tmp32_ = g_free;
			_tmp33_ = sqlite3_bind_text (_tmp29_, 4, _tmp31_, -1, _tmp32_);
			_tmp11_ = _tmp33_ != SQLITE_OK;
		}
		_tmp34_ = _tmp11_;
		if (_tmp34_) {
			XnoiseItem* _tmp35_;
			magnatune_database_reader_db_error (self);
			_tmp35_ = i;
			i = NULL;
			result = _tmp35_;
			_g_free0 (st);
			__vala_XnoiseItem_free0 (i);
			_sqlite3_finalize0 (stmt);
			return result;
		}
		_g_free0 (st);
	} else {
		sqlite3* _tmp36_;
		sqlite3_stmt* _tmp37_ = NULL;
		sqlite3_stmt* _tmp38_;
		gint32 _tmp39_;
		gint _tmp40_ = 0;
		_tmp36_ = self->priv->db;
		sqlite3_prepare_v2 (_tmp36_, MAGNATUNE_DATABASE_READER_STMT_GET_ARTISTITEM_BY_ARTISTID, -1, &_tmp37_, NULL);
		_sqlite3_finalize0 (stmt);
		stmt = _tmp37_;
		_tmp38_ = stmt;
		_tmp39_ = id;
		_tmp40_ = sqlite3_bind_int (_tmp38_, 1, (gint) _tmp39_);
		if (_tmp40_ != SQLITE_OK) {
			XnoiseItem* _tmp41_;
			magnatune_database_reader_db_error (self);
			_tmp41_ = i;
			i = NULL;
			result = _tmp41_;
			__vala_XnoiseItem_free0 (i);
			_sqlite3_finalize0 (stmt);
			return result;
		}
	}
	_tmp42_ = stmt;
	_tmp43_ = sqlite3_step (_tmp42_);
	if (_tmp43_ == SQLITE_ROW) {
		gint32 _tmp44_;
		XnoiseItem _tmp45_ = {0};
		XnoiseItem _tmp46_;
		XnoiseItem* _tmp47_;
		XnoiseItem* _tmp48_;
		sqlite3_stmt* _tmp49_;
		const gchar* _tmp50_ = NULL;
		gchar* _tmp51_;
		XnoiseItem* _tmp52_;
		gint _tmp53_ = 0;
		_tmp44_ = id;
		xnoise_item_init (&_tmp45_, XNOISE_ITEM_TYPE_COLLECTION_CONTAINER_ARTIST, NULL, _tmp44_);
		_tmp46_ = _tmp45_;
		_tmp47_ = __xnoise_item_dup0 (&_tmp46_);
		__vala_XnoiseItem_free0 (i);
		i = _tmp47_;
		xnoise_item_destroy (&_tmp46_);
		_tmp48_ = i;
		_tmp49_ = stmt;
		_tmp50_ = sqlite3_column_text (_tmp49_, 0);
		_tmp51_ = g_strdup (_tmp50_);
		_g_free0 ((*_tmp48_).text);
		(*_tmp48_).text = _tmp51_;
		_tmp52_ = i;
		_tmp53_ = xnoise_data_source_get_source_id ((XnoiseDataSource*) self);
		(*_tmp52_).source_id = _tmp53_;
	}
	_tmp54_ = i;
	i = NULL;
	result = _tmp54_;
	__vala_XnoiseItem_free0 (i);
	_sqlite3_finalize0 (stmt);
	return result;
}


gchar* magnatune_database_reader_get_sku_for_album (MagnatuneDatabaseReader* self, gint32 id) {
	gchar* result = NULL;
	gchar* val;
	sqlite3_stmt* stmt = NULL;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	sqlite3_stmt* _tmp2_;
	gint32 _tmp3_;
	gint _tmp4_ = 0;
	sqlite3_stmt* _tmp5_;
	gint _tmp6_ = 0;
	g_return_val_if_fail (self != NULL, NULL);
	val = NULL;
	_tmp0_ = self->priv->db;
	sqlite3_prepare_v2 (_tmp0_, MAGNATUNE_DATABASE_READER_STMT_GET_SKU_BY_ALBUMID, -1, &_tmp1_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp1_;
	_tmp2_ = stmt;
	_tmp3_ = id;
	_tmp4_ = sqlite3_bind_int (_tmp2_, 1, (gint) _tmp3_);
	if (_tmp4_ != SQLITE_OK) {
		magnatune_database_reader_db_error (self);
		result = NULL;
		_sqlite3_finalize0 (stmt);
		_g_free0 (val);
		return result;
	}
	_tmp5_ = stmt;
	_tmp6_ = sqlite3_step (_tmp5_);
	if (_tmp6_ == SQLITE_ROW) {
		sqlite3_stmt* _tmp7_;
		const gchar* _tmp8_ = NULL;
		gchar* _tmp9_;
		_tmp7_ = stmt;
		_tmp8_ = sqlite3_column_text (_tmp7_, 0);
		_tmp9_ = g_strdup (_tmp8_);
		result = _tmp9_;
		_sqlite3_finalize0 (stmt);
		_g_free0 (val);
		return result;
	}
	result = val;
	_sqlite3_finalize0 (stmt);
	return result;
}


gchar* magnatune_database_reader_get_sku_for_title (MagnatuneDatabaseReader* self, gint32 id) {
	gchar* result = NULL;
	gchar* val;
	sqlite3_stmt* stmt = NULL;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	sqlite3_stmt* _tmp2_;
	gint32 _tmp3_;
	gint _tmp4_ = 0;
	sqlite3_stmt* _tmp5_;
	gint _tmp6_ = 0;
	g_return_val_if_fail (self != NULL, NULL);
	val = NULL;
	_tmp0_ = self->priv->db;
	sqlite3_prepare_v2 (_tmp0_, MAGNATUNE_DATABASE_READER_STMT_GET_SKU_BY_TITLEID, -1, &_tmp1_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp1_;
	_tmp2_ = stmt;
	_tmp3_ = id;
	_tmp4_ = sqlite3_bind_int (_tmp2_, 1, (gint) _tmp3_);
	if (_tmp4_ != SQLITE_OK) {
		magnatune_database_reader_db_error (self);
		result = NULL;
		_sqlite3_finalize0 (stmt);
		_g_free0 (val);
		return result;
	}
	_tmp5_ = stmt;
	_tmp6_ = sqlite3_step (_tmp5_);
	if (_tmp6_ == SQLITE_ROW) {
		sqlite3_stmt* _tmp7_;
		const gchar* _tmp8_ = NULL;
		gchar* _tmp9_;
		_tmp7_ = stmt;
		_tmp8_ = sqlite3_column_text (_tmp7_, 0);
		_tmp9_ = g_strdup (_tmp8_);
		result = _tmp9_;
		_sqlite3_finalize0 (stmt);
		_g_free0 (val);
		return result;
	}
	result = val;
	_sqlite3_finalize0 (stmt);
	return result;
}


static void _vala_array_add6 (XnoiseTrackData*** array, int* length, int* size, XnoiseTrackData* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (XnoiseTrackData*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static XnoiseTrackData** magnatune_database_reader_real_get_trackdata_by_albumid (XnoiseDataSource* base, const gchar* searchtext, gint32 id, int* result_length1) {
	MagnatuneDatabaseReader * self;
	XnoiseTrackData** result = NULL;
	XnoiseTrackData** _tmp0_ = NULL;
	XnoiseTrackData** val;
	gint val_length1;
	gint _val_size_;
	sqlite3_stmt* stmt = NULL;
	const gchar* _tmp1_;
	XnoiseTrackData** _tmp93_;
	gint _tmp93__length1;
	XnoiseTrackData** _tmp94_;
	gint _tmp94__length1;
	self = (MagnatuneDatabaseReader*) base;
	g_return_val_if_fail (searchtext != NULL, NULL);
	_tmp0_ = g_new0 (XnoiseTrackData*, 0 + 1);
	val = _tmp0_;
	val_length1 = 0;
	_val_size_ = val_length1;
	_tmp1_ = searchtext;
	if (g_strcmp0 (_tmp1_, XNOISE_RESOURCES_EMPTYSTRING) != 0) {
		const gchar* _tmp2_;
		gchar* _tmp3_ = NULL;
		gchar* st;
		sqlite3* _tmp4_;
		sqlite3_stmt* _tmp5_ = NULL;
		gboolean _tmp6_ = FALSE;
		gboolean _tmp7_ = FALSE;
		gboolean _tmp8_ = FALSE;
		gboolean _tmp9_ = FALSE;
		sqlite3_stmt* _tmp10_;
		gint32 _tmp11_;
		gint _tmp12_ = 0;
		gboolean _tmp18_;
		gboolean _tmp24_;
		gboolean _tmp30_;
		gboolean _tmp36_;
		_tmp2_ = searchtext;
		_tmp3_ = g_strdup_printf ("%%%s%%", _tmp2_);
		st = _tmp3_;
		_tmp4_ = self->priv->db;
		sqlite3_prepare_v2 (_tmp4_, MAGNATUNE_DATABASE_READER_STMT_GET_TRACKDATA_BY_ALBUMID_WITH_SEARCH, -1, &_tmp5_, NULL);
		_sqlite3_finalize0 (stmt);
		stmt = _tmp5_;
		_tmp10_ = stmt;
		_tmp11_ = id;
		_tmp12_ = sqlite3_bind_int (_tmp10_, 1, (gint) _tmp11_);
		if (_tmp12_ != SQLITE_OK) {
			_tmp9_ = TRUE;
		} else {
			sqlite3_stmt* _tmp13_;
			const gchar* _tmp14_;
			gchar* _tmp15_;
			GDestroyNotify _tmp16_;
			gint _tmp17_ = 0;
			_tmp13_ = stmt;
			_tmp14_ = st;
			_tmp15_ = g_strdup (_tmp14_);
			_tmp16_ = g_free;
			_tmp17_ = sqlite3_bind_text (_tmp13_, 2, _tmp15_, -1, _tmp16_);
			_tmp9_ = _tmp17_ != SQLITE_OK;
		}
		_tmp18_ = _tmp9_;
		if (_tmp18_) {
			_tmp8_ = TRUE;
		} else {
			sqlite3_stmt* _tmp19_;
			const gchar* _tmp20_;
			gchar* _tmp21_;
			GDestroyNotify _tmp22_;
			gint _tmp23_ = 0;
			_tmp19_ = stmt;
			_tmp20_ = st;
			_tmp21_ = g_strdup (_tmp20_);
			_tmp22_ = g_free;
			_tmp23_ = sqlite3_bind_text (_tmp19_, 3, _tmp21_, -1, _tmp22_);
			_tmp8_ = _tmp23_ != SQLITE_OK;
		}
		_tmp24_ = _tmp8_;
		if (_tmp24_) {
			_tmp7_ = TRUE;
		} else {
			sqlite3_stmt* _tmp25_;
			const gchar* _tmp26_;
			gchar* _tmp27_;
			GDestroyNotify _tmp28_;
			gint _tmp29_ = 0;
			_tmp25_ = stmt;
			_tmp26_ = st;
			_tmp27_ = g_strdup (_tmp26_);
			_tmp28_ = g_free;
			_tmp29_ = sqlite3_bind_text (_tmp25_, 4, _tmp27_, -1, _tmp28_);
			_tmp7_ = _tmp29_ != SQLITE_OK;
		}
		_tmp30_ = _tmp7_;
		if (_tmp30_) {
			_tmp6_ = TRUE;
		} else {
			sqlite3_stmt* _tmp31_;
			const gchar* _tmp32_;
			gchar* _tmp33_;
			GDestroyNotify _tmp34_;
			gint _tmp35_ = 0;
			_tmp31_ = stmt;
			_tmp32_ = st;
			_tmp33_ = g_strdup (_tmp32_);
			_tmp34_ = g_free;
			_tmp35_ = sqlite3_bind_text (_tmp31_, 5, _tmp33_, -1, _tmp34_);
			_tmp6_ = _tmp35_ != SQLITE_OK;
		}
		_tmp36_ = _tmp6_;
		if (_tmp36_) {
			XnoiseTrackData** _tmp37_;
			gint _tmp37__length1;
			XnoiseTrackData** _tmp38_;
			gint _tmp38__length1;
			magnatune_database_reader_db_error (self);
			_tmp37_ = val;
			_tmp37__length1 = val_length1;
			val = NULL;
			_tmp38_ = _tmp37_;
			_tmp38__length1 = _tmp37__length1;
			if (result_length1) {
				*result_length1 = _tmp38__length1;
			}
			result = _tmp38_;
			_g_free0 (st);
			_sqlite3_finalize0 (stmt);
			val = (_vala_array_free (val, val_length1, (GDestroyNotify) xnoise_track_data_unref), NULL);
			return result;
		}
		_g_free0 (st);
	} else {
		sqlite3* _tmp39_;
		sqlite3_stmt* _tmp40_ = NULL;
		sqlite3_stmt* _tmp41_;
		gint32 _tmp42_;
		gint _tmp43_ = 0;
		_tmp39_ = self->priv->db;
		sqlite3_prepare_v2 (_tmp39_, MAGNATUNE_DATABASE_READER_STMT_GET_TRACKDATA_BY_ALBUMID, -1, &_tmp40_, NULL);
		_sqlite3_finalize0 (stmt);
		stmt = _tmp40_;
		_tmp41_ = stmt;
		_tmp42_ = id;
		_tmp43_ = sqlite3_bind_int (_tmp41_, 1, (gint) _tmp42_);
		if (_tmp43_ != SQLITE_OK) {
			XnoiseTrackData** _tmp44_;
			gint _tmp44__length1;
			magnatune_database_reader_db_error (self);
			_tmp44_ = NULL;
			_tmp44__length1 = 0;
			if (result_length1) {
				*result_length1 = _tmp44__length1;
			}
			result = _tmp44_;
			_sqlite3_finalize0 (stmt);
			val = (_vala_array_free (val, val_length1, (GDestroyNotify) xnoise_track_data_unref), NULL);
			return result;
		}
	}
	while (TRUE) {
		sqlite3_stmt* _tmp45_;
		gint _tmp46_ = 0;
		XnoiseTrackData* _tmp47_;
		XnoiseTrackData* td;
		sqlite3_stmt* _tmp48_;
		gint _tmp49_ = 0;
		sqlite3_stmt* _tmp50_;
		const gchar* _tmp51_ = NULL;
		gchar* _tmp52_ = NULL;
		gchar* _tmp53_;
		sqlite3_stmt* _tmp54_;
		gint _tmp55_ = 0;
		XnoiseItem _tmp56_ = {0};
		XnoiseItem _tmp57_;
		XnoiseItem* _tmp58_;
		XnoiseItem* _tmp59_;
		XnoiseItem* i;
		XnoiseItem* _tmp60_;
		gint _tmp61_ = 0;
		XnoiseTrackData* _tmp62_;
		sqlite3_stmt* _tmp63_;
		const gchar* _tmp64_ = NULL;
		gchar* _tmp65_;
		XnoiseTrackData* _tmp66_;
		sqlite3_stmt* _tmp67_;
		const gchar* _tmp68_ = NULL;
		gchar* _tmp69_;
		XnoiseTrackData* _tmp70_;
		sqlite3_stmt* _tmp71_;
		const gchar* _tmp72_ = NULL;
		gchar* _tmp73_;
		XnoiseTrackData* _tmp74_;
		XnoiseItem* _tmp75_;
		XnoiseItem* _tmp76_;
		XnoiseTrackData* _tmp77_;
		sqlite3_stmt* _tmp78_;
		gint _tmp79_ = 0;
		XnoiseTrackData* _tmp80_;
		sqlite3_stmt* _tmp81_;
		gint _tmp82_ = 0;
		XnoiseTrackData* _tmp83_;
		sqlite3_stmt* _tmp84_;
		const gchar* _tmp85_ = NULL;
		gchar* _tmp86_;
		XnoiseTrackData* _tmp87_;
		sqlite3_stmt* _tmp88_;
		gint _tmp89_ = 0;
		XnoiseTrackData** _tmp90_;
		gint _tmp90__length1;
		XnoiseTrackData* _tmp91_;
		XnoiseTrackData* _tmp92_;
		_tmp45_ = stmt;
		_tmp46_ = sqlite3_step (_tmp45_);
		if (!(_tmp46_ == SQLITE_ROW)) {
			break;
		}
		_tmp47_ = xnoise_track_data_new ();
		td = _tmp47_;
		_tmp48_ = stmt;
		_tmp49_ = sqlite3_column_int (_tmp48_, 1);
		_tmp50_ = stmt;
		_tmp51_ = sqlite3_column_text (_tmp50_, 4);
		_tmp52_ = magnatune_database_reader_transform_mag_url (self, _tmp51_);
		_tmp53_ = _tmp52_;
		_tmp54_ = stmt;
		_tmp55_ = sqlite3_column_int (_tmp54_, 2);
		xnoise_item_init (&_tmp56_, (XnoiseItemType) _tmp49_, _tmp53_, (gint32) _tmp55_);
		_tmp57_ = _tmp56_;
		_tmp58_ = __xnoise_item_dup0 (&_tmp57_);
		_tmp59_ = _tmp58_;
		xnoise_item_destroy (&_tmp57_);
		_g_free0 (_tmp53_);
		i = _tmp59_;
		_tmp60_ = i;
		_tmp61_ = xnoise_data_source_get_source_id ((XnoiseDataSource*) self);
		(*_tmp60_).source_id = _tmp61_;
		_tmp62_ = td;
		_tmp63_ = stmt;
		_tmp64_ = sqlite3_column_text (_tmp63_, 5);
		_tmp65_ = g_strdup (_tmp64_);
		_g_free0 (_tmp62_->artist);
		_tmp62_->artist = _tmp65_;
		_tmp66_ = td;
		_tmp67_ = stmt;
		_tmp68_ = sqlite3_column_text (_tmp67_, 6);
		_tmp69_ = g_strdup (_tmp68_);
		_g_free0 (_tmp66_->album);
		_tmp66_->album = _tmp69_;
		_tmp70_ = td;
		_tmp71_ = stmt;
		_tmp72_ = sqlite3_column_text (_tmp71_, 0);
		_tmp73_ = g_strdup (_tmp72_);
		_g_free0 (_tmp70_->title);
		_tmp70_->title = _tmp73_;
		_tmp74_ = td;
		_tmp75_ = i;
		_tmp76_ = __xnoise_item_dup0 (_tmp75_);
		__vala_XnoiseItem_free0 (_tmp74_->item);
		_tmp74_->item = _tmp76_;
		_tmp77_ = td;
		_tmp78_ = stmt;
		_tmp79_ = sqlite3_column_int (_tmp78_, 3);
		_tmp77_->tracknumber = (guint) _tmp79_;
		_tmp80_ = td;
		_tmp81_ = stmt;
		_tmp82_ = sqlite3_column_int (_tmp81_, 7);
		_tmp80_->length = (gint32) _tmp82_;
		_tmp83_ = td;
		_tmp84_ = stmt;
		_tmp85_ = sqlite3_column_text (_tmp84_, 8);
		_tmp86_ = g_strdup (_tmp85_);
		_g_free0 (_tmp83_->genre);
		_tmp83_->genre = _tmp86_;
		_tmp87_ = td;
		_tmp88_ = stmt;
		_tmp89_ = sqlite3_column_int (_tmp88_, 9);
		_tmp87_->year = (guint) _tmp89_;
		_tmp90_ = val;
		_tmp90__length1 = val_length1;
		_tmp91_ = td;
		_tmp92_ = _xnoise_track_data_ref0 (_tmp91_);
		_vala_array_add6 (&val, &val_length1, &_val_size_, _tmp92_);
		__vala_XnoiseItem_free0 (i);
		_xnoise_track_data_unref0 (td);
	}
	_tmp93_ = val;
	_tmp93__length1 = val_length1;
	val = NULL;
	_tmp94_ = _tmp93_;
	_tmp94__length1 = _tmp93__length1;
	if (result_length1) {
		*result_length1 = _tmp94__length1;
	}
	result = _tmp94_;
	_sqlite3_finalize0 (stmt);
	val = (_vala_array_free (val, val_length1, (GDestroyNotify) xnoise_track_data_unref), NULL);
	return result;
}


static void _vala_array_add7 (XnoiseItem** array, int* length, int* size, const XnoiseItem* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (XnoiseItem, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


static XnoiseItem* magnatune_database_reader_real_get_albums_with_search (XnoiseDataSource* base, const gchar* searchtext, gint32 id, int* result_length1) {
	MagnatuneDatabaseReader * self;
	XnoiseItem* result = NULL;
	XnoiseItem* _tmp0_ = NULL;
	XnoiseItem* val;
	gint val_length1;
	gint _val_size_;
	sqlite3_stmt* stmt = NULL;
	const gchar* _tmp1_;
	XnoiseItem* _tmp57_;
	gint _tmp57__length1;
	XnoiseItem* _tmp58_;
	gint _tmp58__length1;
	self = (MagnatuneDatabaseReader*) base;
	g_return_val_if_fail (searchtext != NULL, NULL);
	_tmp0_ = g_new0 (XnoiseItem, 0);
	val = _tmp0_;
	val_length1 = 0;
	_val_size_ = val_length1;
	_tmp1_ = searchtext;
	if (g_strcmp0 (_tmp1_, XNOISE_RESOURCES_EMPTYSTRING) != 0) {
		const gchar* _tmp2_;
		gchar* _tmp3_ = NULL;
		gchar* st;
		sqlite3* _tmp4_;
		sqlite3_stmt* _tmp5_ = NULL;
		gboolean _tmp6_ = FALSE;
		gboolean _tmp7_ = FALSE;
		gboolean _tmp8_ = FALSE;
		gboolean _tmp9_ = FALSE;
		sqlite3_stmt* _tmp10_;
		gint32 _tmp11_;
		gint _tmp12_ = 0;
		gboolean _tmp18_;
		gboolean _tmp24_;
		gboolean _tmp30_;
		gboolean _tmp36_;
		_tmp2_ = searchtext;
		_tmp3_ = g_strdup_printf ("%%%s%%", _tmp2_);
		st = _tmp3_;
		_tmp4_ = self->priv->db;
		sqlite3_prepare_v2 (_tmp4_, MAGNATUNE_DATABASE_READER_STMT_GET_ALBUMS_WITH_SEARCH, -1, &_tmp5_, NULL);
		_sqlite3_finalize0 (stmt);
		stmt = _tmp5_;
		_tmp10_ = stmt;
		_tmp11_ = id;
		_tmp12_ = sqlite3_bind_int (_tmp10_, 1, (gint) _tmp11_);
		if (_tmp12_ != SQLITE_OK) {
			_tmp9_ = TRUE;
		} else {
			sqlite3_stmt* _tmp13_;
			const gchar* _tmp14_;
			gchar* _tmp15_;
			GDestroyNotify _tmp16_;
			gint _tmp17_ = 0;
			_tmp13_ = stmt;
			_tmp14_ = st;
			_tmp15_ = g_strdup (_tmp14_);
			_tmp16_ = g_free;
			_tmp17_ = sqlite3_bind_text (_tmp13_, 2, _tmp15_, -1, _tmp16_);
			_tmp9_ = _tmp17_ != SQLITE_OK;
		}
		_tmp18_ = _tmp9_;
		if (_tmp18_) {
			_tmp8_ = TRUE;
		} else {
			sqlite3_stmt* _tmp19_;
			const gchar* _tmp20_;
			gchar* _tmp21_;
			GDestroyNotify _tmp22_;
			gint _tmp23_ = 0;
			_tmp19_ = stmt;
			_tmp20_ = st;
			_tmp21_ = g_strdup (_tmp20_);
			_tmp22_ = g_free;
			_tmp23_ = sqlite3_bind_text (_tmp19_, 3, _tmp21_, -1, _tmp22_);
			_tmp8_ = _tmp23_ != SQLITE_OK;
		}
		_tmp24_ = _tmp8_;
		if (_tmp24_) {
			_tmp7_ = TRUE;
		} else {
			sqlite3_stmt* _tmp25_;
			const gchar* _tmp26_;
			gchar* _tmp27_;
			GDestroyNotify _tmp28_;
			gint _tmp29_ = 0;
			_tmp25_ = stmt;
			_tmp26_ = st;
			_tmp27_ = g_strdup (_tmp26_);
			_tmp28_ = g_free;
			_tmp29_ = sqlite3_bind_text (_tmp25_, 4, _tmp27_, -1, _tmp28_);
			_tmp7_ = _tmp29_ != SQLITE_OK;
		}
		_tmp30_ = _tmp7_;
		if (_tmp30_) {
			_tmp6_ = TRUE;
		} else {
			sqlite3_stmt* _tmp31_;
			const gchar* _tmp32_;
			gchar* _tmp33_;
			GDestroyNotify _tmp34_;
			gint _tmp35_ = 0;
			_tmp31_ = stmt;
			_tmp32_ = st;
			_tmp33_ = g_strdup (_tmp32_);
			_tmp34_ = g_free;
			_tmp35_ = sqlite3_bind_text (_tmp31_, 5, _tmp33_, -1, _tmp34_);
			_tmp6_ = _tmp35_ != SQLITE_OK;
		}
		_tmp36_ = _tmp6_;
		if (_tmp36_) {
			XnoiseItem* _tmp37_;
			gint _tmp37__length1;
			XnoiseItem* _tmp38_;
			gint _tmp38__length1;
			magnatune_database_reader_db_error (self);
			_tmp37_ = val;
			_tmp37__length1 = val_length1;
			val = NULL;
			_tmp38_ = _tmp37_;
			_tmp38__length1 = _tmp37__length1;
			if (result_length1) {
				*result_length1 = _tmp38__length1;
			}
			result = _tmp38_;
			_g_free0 (st);
			_sqlite3_finalize0 (stmt);
			val = (_vala_XnoiseItem_array_free (val, val_length1), NULL);
			return result;
		}
		_g_free0 (st);
	} else {
		sqlite3* _tmp39_;
		sqlite3_stmt* _tmp40_ = NULL;
		sqlite3_stmt* _tmp41_;
		gint32 _tmp42_;
		gint _tmp43_ = 0;
		_tmp39_ = self->priv->db;
		sqlite3_prepare_v2 (_tmp39_, MAGNATUNE_DATABASE_READER_STMT_GET_ALBUMS, -1, &_tmp40_, NULL);
		_sqlite3_finalize0 (stmt);
		stmt = _tmp40_;
		_tmp41_ = stmt;
		_tmp42_ = id;
		_tmp43_ = sqlite3_bind_int (_tmp41_, 1, (gint) _tmp42_);
		if (_tmp43_ != SQLITE_OK) {
			XnoiseItem* _tmp44_;
			gint _tmp44__length1;
			XnoiseItem* _tmp45_;
			gint _tmp45__length1;
			magnatune_database_reader_db_error (self);
			_tmp44_ = val;
			_tmp44__length1 = val_length1;
			val = NULL;
			_tmp45_ = _tmp44_;
			_tmp45__length1 = _tmp44__length1;
			if (result_length1) {
				*result_length1 = _tmp45__length1;
			}
			result = _tmp45_;
			_sqlite3_finalize0 (stmt);
			val = (_vala_XnoiseItem_array_free (val, val_length1), NULL);
			return result;
		}
	}
	while (TRUE) {
		sqlite3_stmt* _tmp46_;
		gint _tmp47_ = 0;
		sqlite3_stmt* _tmp48_;
		gint _tmp49_ = 0;
		XnoiseItem i = {0};
		sqlite3_stmt* _tmp50_;
		const gchar* _tmp51_ = NULL;
		gchar* _tmp52_;
		gint _tmp53_ = 0;
		XnoiseItem* _tmp54_;
		gint _tmp54__length1;
		XnoiseItem _tmp55_;
		XnoiseItem _tmp56_ = {0};
		_tmp46_ = stmt;
		_tmp47_ = sqlite3_step (_tmp46_);
		if (!(_tmp47_ == SQLITE_ROW)) {
			break;
		}
		_tmp48_ = stmt;
		_tmp49_ = sqlite3_column_int (_tmp48_, 1);
		xnoise_item_init (&i, XNOISE_ITEM_TYPE_COLLECTION_CONTAINER_ALBUM, NULL, (gint32) _tmp49_);
		_tmp50_ = stmt;
		_tmp51_ = sqlite3_column_text (_tmp50_, 0);
		_tmp52_ = g_strdup (_tmp51_);
		_g_free0 (i.text);
		i.text = _tmp52_;
		_tmp53_ = xnoise_data_source_get_source_id ((XnoiseDataSource*) self);
		i.source_id = _tmp53_;
		_tmp54_ = val;
		_tmp54__length1 = val_length1;
		_tmp55_ = i;
		xnoise_item_copy (&_tmp55_, &_tmp56_);
		_vala_array_add7 (&val, &val_length1, &_val_size_, &_tmp56_);
		xnoise_item_destroy (&i);
	}
	_tmp57_ = val;
	_tmp57__length1 = val_length1;
	val = NULL;
	_tmp58_ = _tmp57_;
	_tmp58__length1 = _tmp57__length1;
	if (result_length1) {
		*result_length1 = _tmp58__length1;
	}
	result = _tmp58_;
	_sqlite3_finalize0 (stmt);
	val = (_vala_XnoiseItem_array_free (val, val_length1), NULL);
	return result;
}


static XnoiseTrackData* magnatune_database_reader_real_get_trackdata_by_titleid (XnoiseDataSource* base, const gchar* searchtext, gint32 id) {
	MagnatuneDatabaseReader * self;
	XnoiseTrackData* result = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	sqlite3_stmt* _tmp2_;
	gint32 _tmp3_;
	gint _tmp4_ = 0;
	XnoiseTrackData* td;
	sqlite3_stmt* _tmp5_;
	gint _tmp6_ = 0;
	XnoiseTrackData* _tmp50_;
	self = (MagnatuneDatabaseReader*) base;
	g_return_val_if_fail (searchtext != NULL, NULL);
	_tmp0_ = self->priv->db;
	sqlite3_prepare_v2 (_tmp0_, MAGNATUNE_DATABASE_READER_STMT_GET_TRACKDATA_BY_TITLEID, -1, &_tmp1_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp1_;
	_tmp2_ = stmt;
	_tmp3_ = id;
	_tmp4_ = sqlite3_bind_int (_tmp2_, 1, (gint) _tmp3_);
	if (_tmp4_ != SQLITE_OK) {
		magnatune_database_reader_db_error (self);
		result = NULL;
		_sqlite3_finalize0 (stmt);
		return result;
	}
	td = NULL;
	_tmp5_ = stmt;
	_tmp6_ = sqlite3_step (_tmp5_);
	if (_tmp6_ == SQLITE_ROW) {
		XnoiseTrackData* _tmp7_;
		sqlite3_stmt* _tmp8_;
		gint _tmp9_ = 0;
		sqlite3_stmt* _tmp10_;
		const gchar* _tmp11_ = NULL;
		gchar* _tmp12_ = NULL;
		gchar* _tmp13_;
		sqlite3_stmt* _tmp14_;
		gint _tmp15_ = 0;
		XnoiseItem _tmp16_ = {0};
		XnoiseItem _tmp17_;
		XnoiseItem* _tmp18_;
		XnoiseItem* _tmp19_;
		XnoiseItem* i;
		XnoiseItem* _tmp20_;
		gint _tmp21_ = 0;
		XnoiseTrackData* _tmp22_;
		sqlite3_stmt* _tmp23_;
		const gchar* _tmp24_ = NULL;
		gchar* _tmp25_;
		XnoiseTrackData* _tmp26_;
		sqlite3_stmt* _tmp27_;
		const gchar* _tmp28_ = NULL;
		gchar* _tmp29_;
		XnoiseTrackData* _tmp30_;
		sqlite3_stmt* _tmp31_;
		const gchar* _tmp32_ = NULL;
		gchar* _tmp33_;
		XnoiseTrackData* _tmp34_;
		XnoiseItem* _tmp35_;
		XnoiseItem* _tmp36_;
		XnoiseTrackData* _tmp37_;
		sqlite3_stmt* _tmp38_;
		gint _tmp39_ = 0;
		XnoiseTrackData* _tmp40_;
		sqlite3_stmt* _tmp41_;
		gint _tmp42_ = 0;
		XnoiseTrackData* _tmp43_;
		sqlite3_stmt* _tmp44_;
		const gchar* _tmp45_ = NULL;
		gchar* _tmp46_;
		XnoiseTrackData* _tmp47_;
		sqlite3_stmt* _tmp48_;
		gint _tmp49_ = 0;
		_tmp7_ = xnoise_track_data_new ();
		_xnoise_track_data_unref0 (td);
		td = _tmp7_;
		_tmp8_ = stmt;
		_tmp9_ = sqlite3_column_int (_tmp8_, 1);
		_tmp10_ = stmt;
		_tmp11_ = sqlite3_column_text (_tmp10_, 4);
		_tmp12_ = magnatune_database_reader_transform_mag_url (self, _tmp11_);
		_tmp13_ = _tmp12_;
		_tmp14_ = stmt;
		_tmp15_ = sqlite3_column_int (_tmp14_, 2);
		xnoise_item_init (&_tmp16_, (XnoiseItemType) _tmp9_, _tmp13_, (gint32) _tmp15_);
		_tmp17_ = _tmp16_;
		_tmp18_ = __xnoise_item_dup0 (&_tmp17_);
		_tmp19_ = _tmp18_;
		xnoise_item_destroy (&_tmp17_);
		_g_free0 (_tmp13_);
		i = _tmp19_;
		_tmp20_ = i;
		_tmp21_ = xnoise_data_source_get_source_id ((XnoiseDataSource*) self);
		(*_tmp20_).source_id = _tmp21_;
		_tmp22_ = td;
		_tmp23_ = stmt;
		_tmp24_ = sqlite3_column_text (_tmp23_, 5);
		_tmp25_ = g_strdup (_tmp24_);
		_g_free0 (_tmp22_->artist);
		_tmp22_->artist = _tmp25_;
		_tmp26_ = td;
		_tmp27_ = stmt;
		_tmp28_ = sqlite3_column_text (_tmp27_, 6);
		_tmp29_ = g_strdup (_tmp28_);
		_g_free0 (_tmp26_->album);
		_tmp26_->album = _tmp29_;
		_tmp30_ = td;
		_tmp31_ = stmt;
		_tmp32_ = sqlite3_column_text (_tmp31_, 0);
		_tmp33_ = g_strdup (_tmp32_);
		_g_free0 (_tmp30_->title);
		_tmp30_->title = _tmp33_;
		_tmp34_ = td;
		_tmp35_ = i;
		_tmp36_ = __xnoise_item_dup0 (_tmp35_);
		__vala_XnoiseItem_free0 (_tmp34_->item);
		_tmp34_->item = _tmp36_;
		_tmp37_ = td;
		_tmp38_ = stmt;
		_tmp39_ = sqlite3_column_int (_tmp38_, 3);
		_tmp37_->tracknumber = (guint) _tmp39_;
		_tmp40_ = td;
		_tmp41_ = stmt;
		_tmp42_ = sqlite3_column_int (_tmp41_, 7);
		_tmp40_->length = (gint32) _tmp42_;
		_tmp43_ = td;
		_tmp44_ = stmt;
		_tmp45_ = sqlite3_column_text (_tmp44_, 8);
		_tmp46_ = g_strdup (_tmp45_);
		_g_free0 (_tmp43_->genre);
		_tmp43_->genre = _tmp46_;
		_tmp47_ = td;
		_tmp48_ = stmt;
		_tmp49_ = sqlite3_column_int (_tmp48_, 9);
		_tmp47_->year = (guint) _tmp49_;
		__vala_XnoiseItem_free0 (i);
	}
	_tmp50_ = td;
	td = NULL;
	result = _tmp50_;
	_xnoise_track_data_unref0 (td);
	_sqlite3_finalize0 (stmt);
	return result;
}


static gboolean magnatune_database_reader_real_get_stream_td_for_id (XnoiseDataSource* base, gint32 id, XnoiseTrackData** val) {
	MagnatuneDatabaseReader * self;
	XnoiseTrackData* _vala_val = NULL;
	gboolean result = FALSE;
	gint32 _tmp0_;
	XnoiseTrackData* _tmp1_ = NULL;
	XnoiseTrackData* _tmp2_;
	self = (MagnatuneDatabaseReader*) base;
	_tmp0_ = id;
	_tmp1_ = xnoise_data_source_get_trackdata_by_titleid ((XnoiseDataSource*) self, "", _tmp0_);
	_xnoise_track_data_unref0 (_vala_val);
	_vala_val = _tmp1_;
	_tmp2_ = _vala_val;
	if (_tmp2_ == NULL) {
		result = FALSE;
		if (val) {
			*val = _vala_val;
		} else {
			_xnoise_track_data_unref0 (_vala_val);
		}
		return result;
	}
	result = TRUE;
	if (val) {
		*val = _vala_val;
	} else {
		_xnoise_track_data_unref0 (_vala_val);
	}
	return result;
}


static void _vala_array_add8 (XnoiseTrackData*** array, int* length, int* size, XnoiseTrackData* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (XnoiseTrackData*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static XnoiseTrackData** magnatune_database_reader_real_get_all_tracks (XnoiseDataSource* base, const gchar* searchtext, int* result_length1) {
	MagnatuneDatabaseReader * self;
	XnoiseTrackData** result = NULL;
	sqlite3_stmt* stmt = NULL;
	XnoiseTrackData** _tmp0_ = NULL;
	XnoiseTrackData** retv;
	gint retv_length1;
	gint _retv_size_;
	const gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* st;
	sqlite3* _tmp3_;
	sqlite3_stmt* _tmp4_ = NULL;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	GDestroyNotify _tmp10_;
	gint _tmp11_ = 0;
	gboolean _tmp17_;
	gboolean _tmp23_;
	XnoiseTrackData** _tmp119_;
	gint _tmp119__length1;
	XnoiseTrackData** _tmp120_;
	gint _tmp120__length1;
	self = (MagnatuneDatabaseReader*) base;
	g_return_val_if_fail (searchtext != NULL, NULL);
	_tmp0_ = g_new0 (XnoiseTrackData*, 0 + 1);
	retv = _tmp0_;
	retv_length1 = 0;
	_retv_size_ = retv_length1;
	_tmp1_ = searchtext;
	_tmp2_ = g_strdup_printf ("%%%s%%", _tmp1_);
	st = _tmp2_;
	_tmp3_ = self->priv->db;
	sqlite3_prepare_v2 (_tmp3_, MAGNATUNE_DATABASE_READER_STMT_ALL_TRACKDATA, -1, &_tmp4_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp4_;
	_tmp7_ = stmt;
	_tmp8_ = st;
	_tmp9_ = g_strdup (_tmp8_);
	_tmp10_ = g_free;
	_tmp11_ = sqlite3_bind_text (_tmp7_, 1, _tmp9_, -1, _tmp10_);
	if (_tmp11_ != SQLITE_OK) {
		_tmp6_ = TRUE;
	} else {
		sqlite3_stmt* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		GDestroyNotify _tmp15_;
		gint _tmp16_ = 0;
		_tmp12_ = stmt;
		_tmp13_ = st;
		_tmp14_ = g_strdup (_tmp13_);
		_tmp15_ = g_free;
		_tmp16_ = sqlite3_bind_text (_tmp12_, 2, _tmp14_, -1, _tmp15_);
		_tmp6_ = _tmp16_ != SQLITE_OK;
	}
	_tmp17_ = _tmp6_;
	if (_tmp17_) {
		_tmp5_ = TRUE;
	} else {
		sqlite3_stmt* _tmp18_;
		const gchar* _tmp19_;
		gchar* _tmp20_;
		GDestroyNotify _tmp21_;
		gint _tmp22_ = 0;
		_tmp18_ = stmt;
		_tmp19_ = st;
		_tmp20_ = g_strdup (_tmp19_);
		_tmp21_ = g_free;
		_tmp22_ = sqlite3_bind_text (_tmp18_, 3, _tmp20_, -1, _tmp21_);
		_tmp5_ = _tmp22_ != SQLITE_OK;
	}
	_tmp23_ = _tmp5_;
	if (_tmp23_) {
		XnoiseTrackData** _tmp24_;
		gint _tmp24__length1;
		magnatune_database_reader_db_error (self);
		_tmp24_ = NULL;
		_tmp24__length1 = 0;
		if (result_length1) {
			*result_length1 = _tmp24__length1;
		}
		result = _tmp24_;
		_g_free0 (st);
		retv = (_vala_array_free (retv, retv_length1, (GDestroyNotify) xnoise_track_data_unref), NULL);
		_sqlite3_finalize0 (stmt);
		return result;
	}
	while (TRUE) {
		sqlite3_stmt* _tmp25_;
		gint _tmp26_ = 0;
		XnoiseTrackData* _tmp27_;
		XnoiseTrackData* val;
		XnoiseTrackData* _tmp28_;
		sqlite3_stmt* _tmp29_;
		const gchar* _tmp30_ = NULL;
		gchar* _tmp31_;
		XnoiseTrackData* _tmp32_;
		sqlite3_stmt* _tmp33_;
		const gchar* _tmp34_ = NULL;
		gchar* _tmp35_;
		XnoiseTrackData* _tmp36_;
		sqlite3_stmt* _tmp37_;
		const gchar* _tmp38_ = NULL;
		gchar* _tmp39_;
		XnoiseTrackData* _tmp40_;
		sqlite3_stmt* _tmp41_;
		gint _tmp42_ = 0;
		XnoiseTrackData* _tmp43_;
		sqlite3_stmt* _tmp44_;
		gint _tmp45_ = 0;
		XnoiseTrackData* _tmp46_;
		sqlite3_stmt* _tmp47_;
		gint _tmp48_ = 0;
		sqlite3_stmt* _tmp49_;
		const gchar* _tmp50_ = NULL;
		gchar* _tmp51_ = NULL;
		gchar* _tmp52_;
		sqlite3_stmt* _tmp53_;
		gint _tmp54_ = 0;
		XnoiseItem _tmp55_ = {0};
		XnoiseItem _tmp56_;
		XnoiseItem* _tmp57_;
		XnoiseTrackData* _tmp58_;
		XnoiseItem* _tmp59_;
		gint _tmp60_ = 0;
		XnoiseTrackData* _tmp61_;
		sqlite3_stmt* _tmp62_;
		const gchar* _tmp63_ = NULL;
		gchar* _tmp64_;
		XnoiseTrackData* _tmp65_;
		sqlite3_stmt* _tmp66_;
		gint _tmp67_ = 0;
		gboolean _tmp68_ = FALSE;
		XnoiseTrackData* _tmp69_;
		const gchar* _tmp70_;
		gboolean _tmp73_;
		gboolean _tmp76_ = FALSE;
		XnoiseTrackData* _tmp77_;
		const gchar* _tmp78_;
		gboolean _tmp81_;
		gboolean _tmp84_ = FALSE;
		XnoiseTrackData* _tmp85_;
		const gchar* _tmp86_;
		gboolean _tmp89_;
		gboolean _tmp92_ = FALSE;
		XnoiseTrackData* _tmp93_;
		const gchar* _tmp94_;
		gboolean _tmp97_;
		XnoiseTrackData** _tmp116_;
		gint _tmp116__length1;
		XnoiseTrackData* _tmp117_;
		XnoiseTrackData* _tmp118_;
		_tmp25_ = stmt;
		_tmp26_ = sqlite3_step (_tmp25_);
		if (!(_tmp26_ == SQLITE_ROW)) {
			break;
		}
		_tmp27_ = xnoise_track_data_new ();
		val = _tmp27_;
		_tmp28_ = val;
		_tmp29_ = stmt;
		_tmp30_ = sqlite3_column_text (_tmp29_, 0);
		_tmp31_ = g_strdup (_tmp30_);
		_g_free0 (_tmp28_->artist);
		_tmp28_->artist = _tmp31_;
		_tmp32_ = val;
		_tmp33_ = stmt;
		_tmp34_ = sqlite3_column_text (_tmp33_, 1);
		_tmp35_ = g_strdup (_tmp34_);
		_g_free0 (_tmp32_->album);
		_tmp32_->album = _tmp35_;
		_tmp36_ = val;
		_tmp37_ = stmt;
		_tmp38_ = sqlite3_column_text (_tmp37_, 2);
		_tmp39_ = g_strdup (_tmp38_);
		_g_free0 (_tmp36_->title);
		_tmp36_->title = _tmp39_;
		_tmp40_ = val;
		_tmp41_ = stmt;
		_tmp42_ = sqlite3_column_int (_tmp41_, 3);
		_tmp40_->tracknumber = (guint) _tmp42_;
		_tmp43_ = val;
		_tmp44_ = stmt;
		_tmp45_ = sqlite3_column_int (_tmp44_, 6);
		_tmp43_->length = (gint32) _tmp45_;
		_tmp46_ = val;
		_tmp47_ = stmt;
		_tmp48_ = sqlite3_column_int (_tmp47_, 4);
		_tmp49_ = stmt;
		_tmp50_ = sqlite3_column_text (_tmp49_, 5);
		_tmp51_ = magnatune_database_reader_transform_mag_url (self, _tmp50_);
		_tmp52_ = _tmp51_;
		_tmp53_ = stmt;
		_tmp54_ = sqlite3_column_int (_tmp53_, 7);
		xnoise_item_init (&_tmp55_, (XnoiseItemType) _tmp48_, _tmp52_, (gint32) _tmp54_);
		_tmp56_ = _tmp55_;
		_tmp57_ = __xnoise_item_dup0 (&_tmp56_);
		__vala_XnoiseItem_free0 (_tmp46_->item);
		_tmp46_->item = _tmp57_;
		xnoise_item_destroy (&_tmp56_);
		_g_free0 (_tmp52_);
		_tmp58_ = val;
		_tmp59_ = _tmp58_->item;
		_tmp60_ = xnoise_data_source_get_source_id ((XnoiseDataSource*) self);
		(*_tmp59_).source_id = _tmp60_;
		_tmp61_ = val;
		_tmp62_ = stmt;
		_tmp63_ = sqlite3_column_text (_tmp62_, 8);
		_tmp64_ = g_strdup (_tmp63_);
		_g_free0 (_tmp61_->genre);
		_tmp61_->genre = _tmp64_;
		_tmp65_ = val;
		_tmp66_ = stmt;
		_tmp67_ = sqlite3_column_int (_tmp66_, 9);
		_tmp65_->year = (guint) _tmp67_;
		_tmp69_ = val;
		_tmp70_ = _tmp69_->artist;
		if (g_strcmp0 (_tmp70_, XNOISE_RESOURCES_EMPTYSTRING) == 0) {
			_tmp68_ = TRUE;
		} else {
			XnoiseTrackData* _tmp71_;
			const gchar* _tmp72_;
			_tmp71_ = val;
			_tmp72_ = _tmp71_->artist;
			_tmp68_ = _tmp72_ == NULL;
		}
		_tmp73_ = _tmp68_;
		if (_tmp73_) {
			XnoiseTrackData* _tmp74_;
			gchar* _tmp75_;
			_tmp74_ = val;
			_tmp75_ = g_strdup (XNOISE_RESOURCES_UNKNOWN_ARTIST);
			_g_free0 (_tmp74_->artist);
			_tmp74_->artist = _tmp75_;
		}
		_tmp77_ = val;
		_tmp78_ = _tmp77_->album;
		if (g_strcmp0 (_tmp78_, XNOISE_RESOURCES_EMPTYSTRING) == 0) {
			_tmp76_ = TRUE;
		} else {
			XnoiseTrackData* _tmp79_;
			const gchar* _tmp80_;
			_tmp79_ = val;
			_tmp80_ = _tmp79_->album;
			_tmp76_ = _tmp80_ == NULL;
		}
		_tmp81_ = _tmp76_;
		if (_tmp81_) {
			XnoiseTrackData* _tmp82_;
			gchar* _tmp83_;
			_tmp82_ = val;
			_tmp83_ = g_strdup (XNOISE_RESOURCES_UNKNOWN_ALBUM);
			_g_free0 (_tmp82_->album);
			_tmp82_->album = _tmp83_;
		}
		_tmp85_ = val;
		_tmp86_ = _tmp85_->genre;
		if (g_strcmp0 (_tmp86_, XNOISE_RESOURCES_EMPTYSTRING) == 0) {
			_tmp84_ = TRUE;
		} else {
			XnoiseTrackData* _tmp87_;
			const gchar* _tmp88_;
			_tmp87_ = val;
			_tmp88_ = _tmp87_->genre;
			_tmp84_ = _tmp88_ == NULL;
		}
		_tmp89_ = _tmp84_;
		if (_tmp89_) {
			XnoiseTrackData* _tmp90_;
			gchar* _tmp91_;
			_tmp90_ = val;
			_tmp91_ = g_strdup (XNOISE_RESOURCES_UNKNOWN_GENRE);
			_g_free0 (_tmp90_->genre);
			_tmp90_->genre = _tmp91_;
		}
		_tmp93_ = val;
		_tmp94_ = _tmp93_->title;
		if (g_strcmp0 (_tmp94_, XNOISE_RESOURCES_EMPTYSTRING) == 0) {
			_tmp92_ = TRUE;
		} else {
			XnoiseTrackData* _tmp95_;
			const gchar* _tmp96_;
			_tmp95_ = val;
			_tmp96_ = _tmp95_->title;
			_tmp92_ = _tmp96_ == NULL;
		}
		_tmp97_ = _tmp92_;
		if (_tmp97_) {
			XnoiseTrackData* _tmp98_;
			gchar* _tmp99_;
			XnoiseTrackData* _tmp100_;
			XnoiseItem* _tmp101_;
			const gchar* _tmp102_;
			GFile* _tmp103_ = NULL;
			GFile* file;
			gchar* fileBasename = NULL;
			GFile* _tmp104_;
			XnoiseTrackData* _tmp113_;
			const gchar* _tmp114_;
			gchar* _tmp115_;
			_tmp98_ = val;
			_tmp99_ = g_strdup (XNOISE_RESOURCES_UNKNOWN_TITLE);
			_g_free0 (_tmp98_->title);
			_tmp98_->title = _tmp99_;
			_tmp100_ = val;
			_tmp101_ = _tmp100_->item;
			_tmp102_ = (*_tmp101_).uri;
			_tmp103_ = g_file_new_for_uri (_tmp102_);
			file = _tmp103_;
			_tmp104_ = file;
			if (_tmp104_ != NULL) {
				GFile* _tmp105_;
				gchar* _tmp106_ = NULL;
				gchar* _tmp107_;
				gchar* _tmp108_ = NULL;
				_tmp105_ = file;
				_tmp106_ = g_file_get_path (_tmp105_);
				_tmp107_ = _tmp106_;
				_tmp108_ = g_filename_display_basename (_tmp107_);
				_g_free0 (fileBasename);
				fileBasename = _tmp108_;
				_g_free0 (_tmp107_);
			} else {
				XnoiseTrackData* _tmp109_;
				XnoiseItem* _tmp110_;
				const gchar* _tmp111_;
				gchar* _tmp112_;
				_tmp109_ = val;
				_tmp110_ = _tmp109_->item;
				_tmp111_ = (*_tmp110_).uri;
				_tmp112_ = g_strdup (_tmp111_);
				_g_free0 (fileBasename);
				fileBasename = _tmp112_;
			}
			_tmp113_ = val;
			_tmp114_ = fileBasename;
			_tmp115_ = g_strdup (_tmp114_);
			_g_free0 (_tmp113_->title);
			_tmp113_->title = _tmp115_;
			_g_free0 (fileBasename);
			_g_object_unref0 (file);
		}
		_tmp116_ = retv;
		_tmp116__length1 = retv_length1;
		_tmp117_ = val;
		_tmp118_ = _xnoise_track_data_ref0 (_tmp117_);
		_vala_array_add8 (&retv, &retv_length1, &_retv_size_, _tmp118_);
		_xnoise_track_data_unref0 (val);
	}
	_tmp119_ = retv;
	_tmp119__length1 = retv_length1;
	retv = NULL;
	_tmp120_ = _tmp119_;
	_tmp120__length1 = _tmp119__length1;
	if (result_length1) {
		*result_length1 = _tmp120__length1;
	}
	result = _tmp120_;
	_g_free0 (st);
	retv = (_vala_array_free (retv, retv_length1, (GDestroyNotify) xnoise_track_data_unref), NULL);
	_sqlite3_finalize0 (stmt);
	return result;
}


const gchar* magnatune_database_reader_get_username (MagnatuneDatabaseReader* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_username;
	result = _tmp0_;
	return result;
}


void magnatune_database_reader_set_username (MagnatuneDatabaseReader* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	const gchar* _tmp5_;
	gboolean _tmp7_;
	gboolean _tmp9_;
	gboolean _tmp11_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_username);
	self->priv->_username = _tmp1_;
	_tmp5_ = self->priv->_username;
	if (_tmp5_ != NULL) {
		const gchar* _tmp6_;
		_tmp6_ = self->priv->_username;
		_tmp4_ = g_strcmp0 (_tmp6_, XNOISE_RESOURCES_EMPTYSTRING) != 0;
	} else {
		_tmp4_ = FALSE;
	}
	_tmp7_ = _tmp4_;
	if (_tmp7_) {
		const gchar* _tmp8_;
		_tmp8_ = self->priv->_password;
		_tmp3_ = _tmp8_ != NULL;
	} else {
		_tmp3_ = FALSE;
	}
	_tmp9_ = _tmp3_;
	if (_tmp9_) {
		const gchar* _tmp10_;
		_tmp10_ = self->priv->_password;
		_tmp2_ = g_strcmp0 (_tmp10_, XNOISE_RESOURCES_EMPTYSTRING) != 0;
	} else {
		_tmp2_ = FALSE;
	}
	_tmp11_ = _tmp2_;
	if (_tmp11_) {
		magnatune_database_reader_set_login_data_available (self, TRUE);
	} else {
		magnatune_database_reader_set_login_data_available (self, FALSE);
	}
	g_object_notify ((GObject *) self, "username");
}


const gchar* magnatune_database_reader_get_password (MagnatuneDatabaseReader* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_password;
	result = _tmp0_;
	return result;
}


void magnatune_database_reader_set_password (MagnatuneDatabaseReader* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	const gchar* _tmp5_;
	gboolean _tmp7_;
	gboolean _tmp9_;
	gboolean _tmp11_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_password);
	self->priv->_password = _tmp1_;
	_tmp5_ = self->priv->_username;
	if (_tmp5_ != NULL) {
		const gchar* _tmp6_;
		_tmp6_ = self->priv->_username;
		_tmp4_ = g_strcmp0 (_tmp6_, XNOISE_RESOURCES_EMPTYSTRING) != 0;
	} else {
		_tmp4_ = FALSE;
	}
	_tmp7_ = _tmp4_;
	if (_tmp7_) {
		const gchar* _tmp8_;
		_tmp8_ = self->priv->_password;
		_tmp3_ = _tmp8_ != NULL;
	} else {
		_tmp3_ = FALSE;
	}
	_tmp9_ = _tmp3_;
	if (_tmp9_) {
		const gchar* _tmp10_;
		_tmp10_ = self->priv->_password;
		_tmp2_ = g_strcmp0 (_tmp10_, XNOISE_RESOURCES_EMPTYSTRING) != 0;
	} else {
		_tmp2_ = FALSE;
	}
	_tmp11_ = _tmp2_;
	if (_tmp11_) {
		const gchar* _tmp12_;
		gchar* _tmp13_ = NULL;
		gchar* _tmp14_;
		const gchar* _tmp15_;
		gchar* _tmp16_ = NULL;
		gchar* _tmp17_;
		gchar* _tmp18_ = NULL;
		magnatune_database_reader_set_login_data_available (self, TRUE);
		_tmp12_ = self->priv->_username;
		_tmp13_ = g_uri_escape_string (_tmp12_, NULL, TRUE);
		_tmp14_ = _tmp13_;
		_tmp15_ = self->priv->_password;
		_tmp16_ = g_uri_escape_string (_tmp15_, NULL, TRUE);
		_tmp17_ = _tmp16_;
		_tmp18_ = g_strdup_printf ("http://%s:%s@download.magnatune.com", _tmp14_, _tmp17_);
		_g_free0 (self->priv->http_replacement);
		self->priv->http_replacement = _tmp18_;
		_g_free0 (_tmp17_);
		_g_free0 (_tmp14_);
	} else {
		magnatune_database_reader_set_login_data_available (self, FALSE);
	}
	g_object_notify ((GObject *) self, "password");
}


gboolean magnatune_database_reader_get_login_data_available (MagnatuneDatabaseReader* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_login_data_available;
	result = _tmp0_;
	return result;
}


void magnatune_database_reader_set_login_data_available (MagnatuneDatabaseReader* self, gboolean value) {
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_login_data_available = _tmp0_;
	g_object_notify ((GObject *) self, "login-data-available");
}


static void magnatune_database_reader_class_init (MagnatuneDatabaseReaderClass * klass) {
	magnatune_database_reader_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (MagnatuneDatabaseReaderPrivate));
	XNOISE_DATA_SOURCE_CLASS (klass)->get_datasource_name = magnatune_database_reader_real_get_datasource_name;
	XNOISE_DATA_SOURCE_CLASS (klass)->get_trackdata_for_uri = magnatune_database_reader_real_get_trackdata_for_uri;
	XNOISE_DATA_SOURCE_CLASS (klass)->get_artists_with_search = magnatune_database_reader_real_get_artists_with_search;
	XNOISE_DATA_SOURCE_CLASS (klass)->get_trackdata_by_artistid = magnatune_database_reader_real_get_trackdata_by_artistid;
	XNOISE_DATA_SOURCE_CLASS (klass)->get_artistitem_by_artistid = magnatune_database_reader_real_get_artistitem_by_artistid;
	XNOISE_DATA_SOURCE_CLASS (klass)->get_trackdata_by_albumid = magnatune_database_reader_real_get_trackdata_by_albumid;
	XNOISE_DATA_SOURCE_CLASS (klass)->get_albums_with_search = magnatune_database_reader_real_get_albums_with_search;
	XNOISE_DATA_SOURCE_CLASS (klass)->get_trackdata_by_titleid = magnatune_database_reader_real_get_trackdata_by_titleid;
	XNOISE_DATA_SOURCE_CLASS (klass)->get_stream_td_for_id = magnatune_database_reader_real_get_stream_td_for_id;
	XNOISE_DATA_SOURCE_CLASS (klass)->get_all_tracks = magnatune_database_reader_real_get_all_tracks;
	G_OBJECT_CLASS (klass)->get_property = _vala_magnatune_database_reader_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_magnatune_database_reader_set_property;
	G_OBJECT_CLASS (klass)->finalize = magnatune_database_reader_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAGNATUNE_DATABASE_READER_USERNAME, g_param_spec_string ("username", "username", "username", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAGNATUNE_DATABASE_READER_PASSWORD, g_param_spec_string ("password", "password", "password", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAGNATUNE_DATABASE_READER_LOGIN_DATA_AVAILABLE, g_param_spec_boolean ("login-data-available", "login-data-available", "login-data-available", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void magnatune_database_reader_instance_init (MagnatuneDatabaseReader * self) {
	self->priv = MAGNATUNE_DATABASE_READER_GET_PRIVATE (self);
}


static void magnatune_database_reader_finalize (GObject* obj) {
	MagnatuneDatabaseReader * self;
	self = MAGNATUNE_DATABASE_READER (obj);
	_g_free0 (self->priv->DATABASE);
	_g_free0 (self->priv->_username);
	_g_free0 (self->priv->_password);
	_g_free0 (self->priv->http_replacement);
	_g_object_unref0 (self->priv->cancel);
	_sqlite3_close0 (self->priv->db);
	_sqlite3_finalize0 (self->priv->get_artists_with_search_stmt);
	_sqlite3_finalize0 (self->priv->get_artists_with_search2_stmt);
	G_OBJECT_CLASS (magnatune_database_reader_parent_class)->finalize (obj);
}


GType magnatune_database_reader_get_type (void) {
	return magnatune_database_reader_type_id;
}


GType magnatune_database_reader_register_type (GTypeModule * module) {
	static const GTypeInfo g_define_type_info = { sizeof (MagnatuneDatabaseReaderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) magnatune_database_reader_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MagnatuneDatabaseReader), 0, (GInstanceInitFunc) magnatune_database_reader_instance_init, NULL };
	magnatune_database_reader_type_id = g_type_module_register_type (module, XNOISE_TYPE_DATA_SOURCE, "MagnatuneDatabaseReader", &g_define_type_info, 0);
	return magnatune_database_reader_type_id;
}


static void _vala_magnatune_database_reader_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	MagnatuneDatabaseReader * self;
	self = MAGNATUNE_DATABASE_READER (object);
	switch (property_id) {
		case MAGNATUNE_DATABASE_READER_USERNAME:
		g_value_set_string (value, magnatune_database_reader_get_username (self));
		break;
		case MAGNATUNE_DATABASE_READER_PASSWORD:
		g_value_set_string (value, magnatune_database_reader_get_password (self));
		break;
		case MAGNATUNE_DATABASE_READER_LOGIN_DATA_AVAILABLE:
		g_value_set_boolean (value, magnatune_database_reader_get_login_data_available (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_magnatune_database_reader_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	MagnatuneDatabaseReader * self;
	self = MAGNATUNE_DATABASE_READER (object);
	switch (property_id) {
		case MAGNATUNE_DATABASE_READER_USERNAME:
		magnatune_database_reader_set_username (self, g_value_get_string (value));
		break;
		case MAGNATUNE_DATABASE_READER_PASSWORD:
		magnatune_database_reader_set_password (self, g_value_get_string (value));
		break;
		case MAGNATUNE_DATABASE_READER_LOGIN_DATA_AVAILABLE:
		magnatune_database_reader_set_login_data_available (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



